import datatables from 'datatables';
import Macy from './lib/masonry.js';

jQuery(document).ready(function( $ ) {
	$('[data-piotnetgrid-dropdown-trigger]').click( function(e) {
	    e.preventDefault();
	    $(this).closest('[data-piotnetgrid-dropdown]').find('[data-piotnetgrid-dropdown-content]').toggle();
	}); 
	
	$('[data-piotnetgrid-facet-apply-for-grid]').change(function(){
		var $parent = $(this).closest('td'),
			$shortcode = $parent.find('[data-piotnetgrid-facet-shortcode]'),
			shortcodeValue = $shortcode.val();

		shortcodeValueExplode = shortcodeValue.split('grid=');
		$shortcode.val(shortcodeValueExplode[0] + 'grid=' + $(this).val() + ']');
	});
	$('table.piotnetgrid-analytics').dataTable({
		//searching: true,
	});
	$('.piotnetgrid-analytic-button-group').click(function(){
		$('.piotnetgrid-analytic-button-group').removeClass('piotnetgrid-active');
		$(this).addClass('piotnetgrid-active');
	});

	function piotnetgrid_create_modal($content) {
		$('body').addClass('piotnetgrid-modal-open');
		$(document).find('[data-piotnetgrid-modal]').remove();
		var modalHTML = '<div class="piotnetgrid-modal" data-piotnetgrid-modal><div class="piotnetgrid-modal__inner"><div class="piotnetgrid-modal__content"><div class="piotnetgrid-modal__content-inner" data-piotnetgrid-modal-content>' + $content + '</div></div><div class="piotnetgrid-modal__close" data-piotnetgrid-modal-close><svg width="20px" height="20px" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><g id="Group-14" fill="#000000" fill-rule="nonzero"><polygon id="Line" transform="translate(10.047288, 9.952712) rotate(45.000000) translate(-10.047288, -9.952712) " points="9.04728777 -2.85541277 9.04728777 22.7608372 11.0472878 22.7608372 11.0472878 -2.85541277"></polygon><polygon id="Line-2" transform="translate(10.000000, 10.000000) rotate(45.000000) translate(-10.000000, -10.000000) " points="-2.875 11 22.875 11 22.875 9 -2.875 9"></polygon></g></svg></div></div><div class="piotnetgrid-modal__overlay"></div></div>';
		$('body').append(modalHTML);
	}

	$(document).on('mousedown touchstart',function (e) {
	    //Modal
	    if (!$('[data-piotnetgrid-modal-content], [data-piotnetgrid-modal-content] *').is(e.target)) {
	        $(document).find('[data-piotnetgrid-modal]').addClass('piotnetgrid-fadeout');
	        $('body').removeClass('piotnetgrid-modal-open');
	    }
	});

	function piotnetgridIsJsonString(str) {
	    try {
	        JSON.parse(str);
	    } catch (e) {
	        return false;
	    }
	    return true;
	}

	$(document).on('click', '[data-piotnetgrid-demos-import]', function(){
		var demos = JSON.parse($('[data-piotnetgrid-demos]').attr('data-piotnetgrid-demos')),
			demosHTML = '<div class="piotnetgrid-demos"><div class="piotnetgrid-demos__inner">',
			templatesURL = $('[data-piotnetgrid-plugin-url]').attr('data-piotnetgrid-plugin-url') + '/piotnetgrid/assets/demos/templates/';

		for ( var key in demos ) {
			var demo = demos[key],
				fileURL = typeof(demo.folder) === 'object' ? JSON.stringify(demo.folder) : demo.folder + '/file.json',
				imageURL = '';

			switch(demo.type) {
				case 'card':
				case 'facet':
					imageURL = templatesURL + demo.folder + '/image.jpg';
					break;
				case 'grid':
					imageURL = templatesURL + demo.folder.grid[0] + '/image.jpg';
					break;
				case 'template':
					imageURL = templatesURL + demo.folder.template + '/image.jpg';
					break;
			}

			demosHTML += '<div class="piotnetgrid-demos__item">';
			demosHTML += '<img src="' + imageURL + '">';
			demosHTML += '<div class="piotnetgrid-demos__item-title">' + demo.title + '<span class="piotnetgrid-demos__item-import" data-piotnetgrid-demo-file=' + fileURL + '>Import</span></div>';
			demosHTML += '</div>';
		}

		demosHTML += '</div></div>';

		piotnetgrid_create_modal( demosHTML );

		var macy = Macy({
		    container: '.piotnetgrid-demos__inner',
		    trueOrder: false,
		    // waitForImages: false,
		    margin: 15,
		    columns: 4,
		    breakAt: {
		        1200: 2,
		        400: 1
		    }
		});
	});

	$(document).on('click', '[data-piotnetgrid-demo-file]', function(){
		var $importButton = $(this);
		$importButton.addClass('loading');
		$importButton.removeClass('active');

		var file = $(this).attr('data-piotnetgrid-demo-file'),
			fileURL = piotnetgridIsJsonString(file) ? JSON.parse(file) : file;

		var data = {
			'action': 'piotnetgrid_import_demo',
			'file': fileURL,
		};

		$.post(ajaxurl, data, function(response) {
			$importButton.removeClass('loading');
			$importButton.addClass('active');
			location.reload();
		});
	});
});
