jQuery(document).ready(function($) {
	//Reset Filter
	$(document).on('click', '[data-piotnetgrid-facet-reset]', function(){
		let facetData, filterType, filterElement, isChange = false, facetUrl;
		facetUrl = window.location.href;
		facetUrl = facetUrl.substr(0, facetUrl.indexOf('?'));
		window.history.pushState({}, '', facetUrl);
		let $facets = $(document).find('[data-piotnetgrid-facet]');
		var $filterElementIsChange = undefined;
		$.each($facets, function(index, item){
			facetData = $(this).attr('data-piotnetgrid-facet');
			facetData = JSON.parse(facetData);
			filterType = facetData.filter_type;
			switch (facetData.action){
				case 'filter':
					switch (filterType){
						case 'radio':
							filterElement = $(this).find('[data-piotnetgrid-facet-field]:checked');
							if(filterElement.val()){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.prop('checked', false);
								$(this).find('[data-piotnetgrid-facet-field]').filter('[value=""]').prop('checked', true);
							}
							break;
						case 'select':
							filterElement = $(this).find('[data-piotnetgrid-facet-field]');
							if(filterElement.val()){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.val('');
							}
							break;
						case 'slider':
							filterElement = $(this).find('[data-piotnetgrid-facet-field]');
							$filterElementIsChange = filterElement;
							isChange = true;
							filterElement.val('');
							if ($(this).find('[data-piotnetgrid-facet-slider-bar]')[0].noUiSlider !== undefined) {
								$(this).find('[data-piotnetgrid-facet-slider-bar]')[0].noUiSlider.destroy();
							}
							break;
						case 'checkboxes':
							filterElement =  $(this).find('[data-piotnetgrid-facet-field]:checked');
							if(filterElement.length > 0){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.prop('checked', false);
							}
							break;
						case 'search':
						case 'date':
							filterElement =  $(this).find('[data-piotnetgrid-facet-field]');
							if(filterElement.val()){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.val('');
								filterElement.trigger('keyup');
							}
							break;
					}
					break;

				case 'load':
					switch (facetData.loading_type) {
						case 'pagination':
							filterElement = $(this).find('[data-piotnetgrid-facet-field]');
							if(filterElement.val()){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.val('');
							}
							break;
						case 'posts_per_page':
							filterElement = $(this).find('[data-piotnetgrid-facet-field]');
							if(filterElement.val()){
								$filterElementIsChange = filterElement;
								isChange = true;
								filterElement.find('option:selected').prop('selected', false);
							}
							break;
					}
					
					break;

				case 'sort':
					filterElement = $(this).find('[data-piotnetgrid-facet-field]');
					if(filterElement.val()){
						$filterElementIsChange = filterElement;
						isChange = true;
						filterElement.val('');
					}
					break;
			}
		});

		if(isChange){
			if ($filterElementIsChange) {
				window.piotnetgridFacet($filterElementIsChange,true);
			}
			$('[data-piotnetgrid-facet-active]').empty();
			$('[data-piotnetgrid-facet-active-wrapper]').hide();
		}
	});

	//Facet Active
	const facetElementFields = $(document).find('[data-piotnetgrid-facet-field]');
	const removeIcon = '<svg viewBox="0 0 45.334 45.334"><path d="M43.576,35.092L31.152,22.668l12.424-12.424c2.343-2.343,2.343-6.142,0-8.485c-2.343-2.343-6.142-2.343-8.485,0   L22.666,14.183L10.242,1.758c-2.344-2.343-6.143-2.343-8.485,0c-2.343,2.344-2.343,6.143,0,8.485l12.425,12.424L1.757,35.091   c-2.343,2.344-2.343,6.143,0,8.485C2.93,44.748,4.464,45.333,6,45.333c1.535,0,3.071-0.586,4.243-1.757l12.423-12.423   l12.425,12.424c1.173,1.171,2.707,1.757,4.243,1.757s3.071-0.586,4.243-1.757C45.919,41.234,45.919,37.436,43.576,35.092z" /></svg>';

	$(document).on( 'keyup change','[data-piotnetgrid-facet-field]', $.debounce( 250, function(){
		let activeItem;
		let $facetParent = $(this).closest('[data-piotnetgrid-facet]');
		let facetGrid = $facetParent.attr('data-piotnetgrid-facet-grid');
		let faceElementData = $facetParent.attr('data-piotnetgrid-facet');
		let faceElementDataObj = JSON.parse(faceElementData);
		let facetActive = $(document).find('[data-piotnetgrid-facet-active="' + facetGrid + '"]');

		switch(faceElementDataObj.filter_type){
			case 'select':
				if($(this).val()){
					let selectLabel = $(this).children("option").filter(":selected").attr('data-piotnetgrid-option-label');
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="select"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+selectLabel+'</li>');
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="select"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
				}
				break;
			case 'radio':
				if($(this).val() && $(this).is(':checked')){
					let labelFacet = $(this).closest('.piotnetgrid-facet__field-sub').find('[data-piotnetgrid-option-label]').attr('data-piotnetgrid-option-label');
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="radio"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+labelFacet+'</li>');
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="radio"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
				}
				break;
			case 'checkboxes':
				if($(this).is(':checked')){
					let labelFacet = $(this).closest('.piotnetgrid-facet__field-sub').find('[data-piotnetgrid-option-label]').attr('data-piotnetgrid-option-label');
					if (facetActive.find('[data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"][data-piotnetgrid-filter-value="'+$(this).val()+'"]').length == 0) {
						facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+labelFacet+'</li>');
					}
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="checkboxes"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"][data-piotnetgrid-filter-value="'+$(this).val()+'"]').remove();
				}
				break;
			case 'search':
				if($(this).val()){
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="search"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+$(this).val()+'</li>');
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="search"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
				}
				break;
			case 'date':
				if($(this).val()){
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="date"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+$(this).val()+'</li>');
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="date"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
				}
				break;
			case 'slider':
				if($(this).val()){
					let facetSliderValue = $(this).closest('.piotnetgrid-facet__field-wrapper').find('[data-piotnetgrid-facet-slider-value]').text();
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="slider"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+faceElementDataObj.id+' data-piotnetgrid-facet-active-type="'+faceElementDataObj.filter_type+'" data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'" data-piotnetgrid-filter-value="'+$(this).val()+'">'+removeIcon+'&ensp;'+facetSliderValue+'</li>');
				}else{
					$('[data-piotnetgrid-facet-active-id="'+faceElementDataObj.id+'"][data-piotnetgrid-facet-active-type="slider"][data-piotnetgrid-facet-active-name="'+faceElementDataObj.name+'"]').remove();
				}
				break;
		}

		if(facetActive.find('[data-piotnetgrid-facet-active-id]').length == 0) {
			facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').hide();
		} else {
			facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').show();
		}
	})
	);
	//Remove when click facet active
	$(document).on('click', '.piotnetgrid-facet-active-item', function(){
		let facetID = $(this).attr('data-piotnetgrid-facet-active-id');
		let facetType= $(this).attr('data-piotnetgrid-facet-active-type');
		let facetname = $(this).attr('data-piotnetgrid-facet-active-name');
		let facetElement = $('[data-piotnetgrid-facet-id='+facetID+']');
		let facetValue = $(this).attr('data-piotnetgrid-filter-value');
		let facetItem;
		var facetActive = $(this).closest('[data-piotnetgrid-facet-active]'),
			grid_post_id = facetActive.attr('data-piotnetgrid-facet-active'),
			$apply_facets = $(document).find('[data-piotnetgrid-apply-facets=' + grid_post_id + ']'),
			disable_facets_action = false;

		if ($apply_facets.length > 0) {
			var disable_facets_action = $apply_facets.attr('data-piotnetgrid-disable-facets-action') !== undefined && $apply_facets.attr('data-piotnetgrid-disable-facets-action-deactive') == undefined ? true : false;
		}

		if (!disable_facets_action) {
			facetActive.addClass('piotnetgrid-loading');
		}
		
		switch (facetType){
			case 'select':
				facetElement.find('[data-piotnetgrid-facet-field]').val('');
				$(this).remove();
				facetElement.find('[data-piotnetgrid-facet-field]').change();
				break;
			case 'radio':
				facetItem = facetElement.find('input[value="'+facetValue+'"]');
				facetItem.prop('checked', false).change();
				$(this).remove();
				break;
			case 'checkboxes':
				facetItem = facetElement.find('input[value="'+facetValue+'"]');
				facetItem.prop('checked', false);
				facetItem.change();
				$(this).remove();
				break;
			case 'search':
				facetItem = facetElement.find('input[type="text"][data-piotnetgrid-facet-field]');
				facetItem.val('');
				$(this).remove();
				facetItem.change();
				facetItem.trigger('keyup');
				break;
			case 'date':
				facetItem = facetElement.find('input[type="text"][data-piotnetgrid-facet-field]');
				facetItem.val('');
				facetItem.change();
				$(this).remove();
				break;
			case 'slider':
				facetElement.find('[data-piotnetgrid-facet-field]').val('').change();
				facetElement.find('[data-piotnetgrid-facet-slider-bar]')[0].noUiSlider.destroy();
				window.piotnetgridFacetSlider(facetElement, true);
				$(this).remove();
				break;
		}

		if(facetActive.find('[data-piotnetgrid-facet-active-id]').length == 0) {
			facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').hide();
		} else {
			facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').show();
		}
	});

	$('[data-piotnetgrid-facet-active-wrapper]').each(function(){
		if($(this).find('[data-piotnetgrid-facet-active-id]').length == 0) {
			$(this).hide();
		}
	});

	//Reload Page show facet active
	const facetList = $('[data-piotnetgrid-facet]');
	let currentUrl = window.location.href;
	$.each(facetList, function(index, item){
		let facetLabel, facetValue, facetParamArr, facetSliderStart, facetSliderRight;
		let facetData = $(this).attr('data-piotnetgrid-facet');
		facetData = JSON.parse(facetData);
		let facetGrid = $(this).attr('data-piotnetgrid-facet-grid');
		let facetActive = $(document).find('[data-piotnetgrid-facet-active="' + facetGrid + '"]');
		let facetParam = window.piotnetgridGetUrlParameter(facetData.name, currentUrl), facetParent;
		if(facetParam){
			switch (facetData.filter_type){
				case 'select':
					facetLabel = $(this).find('[data-piotnetgrid-facet-field]').children("option").filter(":selected").attr('data-piotnetgrid-option-label');
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+facetParam+'">'+removeIcon+'&ensp;'+facetLabel+'</li>');
					break;
				case 'radio':
					facetLabel = $(this).find('[data-piotnetgrid-facet-field]:checked').closest('.piotnetgrid-facet__field-sub').find('[data-piotnetgrid-option-label]').attr('data-piotnetgrid-option-label');
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+facetParam+'">'+removeIcon+'&ensp;'+facetLabel+'</li>');
					break;
				case 'checkboxes':
					facetParam = facetParam.split(',');
					facetParent = $(this);
					$.each(facetParam, function(key, value){
						facetLabel = facetParent.find('[data-piotnetgrid-facet-field][value="'+value+'"]').closest('.piotnetgrid-facet__field-sub').find('[data-piotnetgrid-option-label]').attr('data-piotnetgrid-option-label');
						facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+value+'">'+removeIcon+'&ensp;'+facetLabel+'</li>');
					});
					break;
				case 'search':
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+facetParam+'">'+removeIcon+'&ensp;'+facetParam+'</li>');
					break;
				case 'date':
					facetValue = $(this).find('[data-piotnetgrid-facet-field]').val();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+facetValue+'">'+removeIcon+'&ensp;'+facetValue+'</li>');
					break;
				case "slider":
					let facetSliderValue = $(this).find('[data-piotnetgrid-facet-slider-value]').text();
					facetActive.append('<li class="piotnetgrid-facet-active-item" data-piotnetgrid-facet-active-id='+facetData.id+' data-piotnetgrid-facet-active-type="'+facetData.filter_type+'" data-piotnetgrid-facet-active-name="'+facetData.name+'" data-piotnetgrid-filter-value="'+facetParam+'">'+removeIcon+'&ensp;'+ facetSliderValue +'</li>');
					break;
			}

			if(facetActive.find('[data-piotnetgrid-facet-active-id]').length == 0) {
				facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').hide();
			} else {
				facetActive.closest('[data-piotnetgrid-facet-active-wrapper]').show();
			}
		}
	});

	$(document).on('click', '[data-piotnetgrid-add-to-wishlist-action]', function(){
		var $parent = $(this).closest('[data-piotnetgrid-add-to-wishlist]'),
			post_id = $parent.attr('data-piotnetgrid-add-to-wishlist'),
			wishlist_action = $(this).attr('data-piotnetgrid-add-to-wishlist-action'),
			wishlist_list = sessionStorage.getItem('piotnetgrid_wishlist') ? sessionStorage.getItem('piotnetgrid_wishlist').split(',') : [];

		$parent.addClass('piotnetgrid-loading');

		switch (wishlist_action) {
			case 'add':
				wishlist_list.push(post_id);
				break;

			case 'remove':
				var wishlist_index = wishlist_list.indexOf(post_id);
				if (wishlist_index > -1) {
					wishlist_list.splice(wishlist_index, 1);
				}
				break;
		}

		sessionStorage.setItem('piotnetgrid_wishlist', wishlist_list);

		var data = {
			'action': 'piotnetgrid_add_to_wishlist',
			'post_id': post_id,
			'wishlist_action': wishlist_action
		};

		$.post(ajaxurl, data, function(response) {
	    	$parent.removeClass('piotnetgrid-loading');
	    	$parent.toggleClass('piotnetgrid-add-to-wishlist--active');
		});
	});

	function piotnetgrid_create_modal($content) {
		$(document).find('[data-piotnetgrid-modal]').remove();
		var modalHTML = '<div class="piotnetgrid-modal" data-piotnetgrid-modal><div class="piotnetgrid-modal__inner"><div class="piotnetgrid-modal__content"><div class="piotnetgrid-modal__content-inner" data-piotnetgrid-modal-content>' + $content + '</div></div><div class="piotnetgrid-modal__close" data-piotnetgrid-modal-close><svg width="20px" height="20px" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"><g id="Group-14" fill="#000000" fill-rule="nonzero"><polygon id="Line" transform="translate(10.047288, 9.952712) rotate(45.000000) translate(-10.047288, -9.952712) " points="9.04728777 -2.85541277 9.04728777 22.7608372 11.0472878 22.7608372 11.0472878 -2.85541277"></polygon><polygon id="Line-2" transform="translate(10.000000, 10.000000) rotate(45.000000) translate(-10.000000, -10.000000) " points="-2.875 11 22.875 11 22.875 9 -2.875 9"></polygon></g></svg></div></div><div class="piotnetgrid-modal__overlay"></div></div>';
		$('body').append(modalHTML);
	}

	$(document).on('click', '[data-piotnetgrid-quick-view]', function(){
		var post_id = $(this).attr('data-piotnetgrid-quick-view'),
			$button = $(this);

		$(this).addClass('piotnetgrid-loading');

		var data = {
			'action': 'piotnetgrid_quick_view',
			'post_id': post_id,
		};

		$.post(ajaxurl, data, function(response) {
			$('body').addClass('piotnetgrid-modal-open');
			piotnetgrid_create_modal(response);
	    	$button.removeClass('piotnetgrid-loading');

	    	$modal = $(document).find('[data-piotnetgrid-modal-content]');

	    	// Variation Form
			var $form_variation = $modal.find('.variations_form');
            $form_variation.each( function() {
                $( this ).wc_variation_form();
            });

            $form_variation.trigger( 'check_variations' );
            $form_variation.trigger( 'reset_image' );

            if( typeof $.fn.wc_product_gallery !== 'undefined' ) {
                $modal.find('.woocommerce-product-gallery').each(function () {
                    $(this).wc_product_gallery();
                });
            }
		});
	});

	$(document).on('click', '[data-piotnetgrid-modal-close]', function(){
		$(document).find('[data-piotnetgrid-modal]').remove();
	});

	$(document).on('mousedown touchstart',function (e) {
	    //Modal
	    if (!$('[data-piotnetgrid-modal-content], [data-piotnetgrid-modal-content] *').is(e.target)) {
	        $(document).find('[data-piotnetgrid-modal]').addClass('piotnetgrid-fadeout');
	        $('body').removeClass('piotnetgrid-modal-open');
	    }
	});


	function piotnetgrid_get_variation($attributes, $variations) {
		for (var i = 0; i < $variations.length; i++) {
			var matching = false;
			for(var k in $variations[i]['attributes']) {
				if ($variations[i]['attributes'][k] == '') {
					matching = true;
				} else {
					if ($variations[i]['attributes'][k] == $attributes[k]) {
						matching = true;
					} else {
						matching = false;
						break;
					}
				}
			}

			if (matching) {
				var variation = $variations[i];
			}
		}

		return variation;
	}

	$(document).on('change', '#piotnetgrid [data-piotnetgrid-variation-swatches-attribute-field]', function() {
		var $parent = $(this).closest('[data-piotnetgrid-product-variations]'),
			variations = $parent.attr('data-piotnetgrid-product-variations') !== undefined ? JSON.parse($parent.attr('data-piotnetgrid-product-variations')) : [],
			$card = $(this).closest('.piotnetgrid-card'),
			$variationImage = $card.find('[data-piotnetgrid-variation-image]'),
			$variationPrice = $card.find('[data-piotnetgrid-price]'),
			$attributes = $parent.find('.piotnetgrid-variation-swatches__attribute'),
			attributes = {},
			$addToCartButton = $card.find('.piotnetgrid-button-atc--simple'),
			$addToCartButtonAjax = $card.find('[data-piotnetgrid-atc-product-variation]'),
			$addToCartButtonAjaxWrapper = $card.find('.piotnetgrid-button-atc--variation'),
			attributeName = $(this).attr('name'),
			variationsContain = [],
			fieldID = $(this).attr('id'),
			$variationSwatchesField = $card.find('[data-piotnetgrid-variation-swatches-attribute-field]').not('[name="' + attributeName + '"]'),
			tagName = $(this)[0].tagName;

		$addToCartButtonAjaxWrapper.find('p').remove();
		$addToCartButtonAjaxWrapper.removeClass('piotnetgrid-button-atc--added');

		if (tagName == 'SELECT') {
			if ($(this).val() !== '') {
				var fieldValue = $(this).val();
			}
		} else {
			if ($(this).is(":checked")) {
				var fieldValue = $(this).val();
				$(this).closest('.piotnetgrid-variation-swatches__attribute-options').find('[data-piotnetgrid-variation-swatches-attribute-field]').not(this).prop('checked',false);
			}
		}

		if (fieldValue !== undefined) {
			for (var i = 0; i < variations.length; i++) {
				if (variations[i]['attributes'][attributeName] == '' || variations[i]['attributes'][attributeName] == fieldValue) {
					variationsContain.push(variations[i]['attributes']);
				}
			}

			if (variationsContain.length > 0) {				
				$variationSwatchesField.each(function(){
					var foundVariation = [];
					for (var i = 0; i < variationsContain.length; i++) {
						if ($(this)[0].tagName !== 'SELECT' && variationsContain[i][$(this).attr('name')] == $(this).val() || $(this)[0].tagName == 'SELECT' && JSON.parse($(this).attr('data-piotnetgrid-variation-swatches-attribute-field')).includes(variationsContain[i][$(this).attr('name')]) || variationsContain[i][$(this).attr('name')] == '') {
							foundVariation.push(variationsContain[i][$(this).attr('name')]);
						}
					}

					if (foundVariation.length == 0) {
						if ($(this)[0].tagName == 'SELECT') {
							$(this).find('option').prop("disabled", true);
						} else {
							$(this).attr('disabled','').prop('checked', false).attr('data-disabled-reason', fieldID);
						}
					} else {
						if ($(this)[0].tagName == 'SELECT') {
							var notFoundVariation = JSON.parse($(this).attr('data-piotnetgrid-variation-swatches-attribute-field'));

							for (var y = 0; y < foundVariation.length; y++) {
								if (foundVariation[y] == '') {
									notFoundVariation = [];
									$(this).find('option').prop("disabled", false);
								} else {
									if (notFoundVariation.length > 0) {
										var notFoundIndex = notFoundVariation.indexOf(foundVariation[y]);
										if (notFoundIndex > -1) {
											notFoundVariation.splice(notFoundIndex, 1);
										}
										$(this).find('option[value="' + foundVariation[y] + '"]').prop("disabled", false);
									}
								}
							}

							for (var z = 0; z < notFoundVariation.length; z++) {
								$(this).find('option[value="' + notFoundVariation[z] + '"]').prop("disabled", true).attr('data-disabled-reason', fieldID);
							}
						} else {
							if ($(this).attr('disabled') !== undefined) {
								$(this).removeAttr('disabled');
							}
						}
					}
				});
			}
		} else {
			$card.find('[data-disabled-reason="' + fieldID + '"]').removeAttr('disabled').removeAttr('data-disabled-reason');
		}

		var fieldSelectedCount = 0;
		$card.find('select[data-piotnetgrid-variation-swatches-attribute-field]').each(function() {
			if ($(this).val() !== '') { fieldSelectedCount += 1; }
		});

		var completedVariation = $attributes.length == ( $card.find('[data-piotnetgrid-variation-swatches-attribute-field]:checked').length + fieldSelectedCount ) ? true : false;

		if (completedVariation) {
			$addToCartButtonAjaxWrapper.addClass('active');
			$addToCartButton.removeClass('active');
		} else {
			$addToCartButtonAjaxWrapper.removeClass('active');
			$addToCartButton.addClass('active');
		}

		$attributes.each(function(){
			var $attributeField = $(this).find('[data-piotnetgrid-variation-swatches-attribute-field]');

			if ($attributeField[0].tagName == 'SELECT') {
				attributes[$attributeField.attr('name')] = $attributeField.val();
			} else {
				var $checked = $(this).find('input:checked');
				if ($checked.length > 0) {
					attributes[$checked.attr('name')] = $checked.val();
				} else {
					attributes[$(this).find('input').attr('name')] = '';
				}
			}
		});

		var variation = piotnetgrid_get_variation(attributes, variations);

		if (variation !== undefined) {
			var variationID = variation.variation_id;

			if ($variationImage.length > 0) {
				if (variation.image.url) {
					$variationImage.attr('src', variation.image.url);
					$variationImage.closest('.piotnetgrid-image').addClass('piotnetgrid-image-variation-selected');
				} else {
					$variationImage.closest('.piotnetgrid-image').removeClass('piotnetgrid-image-variation-selected');
				}
			}

			if ($addToCartButtonAjax.length > 0) {
				$addToCartButtonAjax.attr('data-piotnetgrid-atc-product-variation', variationID);
				if (variation.availability_html !== '') {
					$addToCartButtonAjaxWrapper.prepend(variation.availability_html);
					if (!variation.is_in_stock) {
						$addToCartButtonAjax.addClass('piotnetgrid-loading');
					} else {
						$addToCartButtonAjax.removeClass('piotnetgrid-loading');
					}
				} else {
					$addToCartButtonAjax.removeClass('piotnetgrid-loading');
				}
			}

			if ($variationPrice.length > 0 && completedVariation) {
				$card.find('.piotnetgrid-wc-price').addClass('inactive');
				$variationPrice.html(variation.price_html);
				$variationPrice.addClass('active');
			}
		} else {
			if ($variationImage.length > 0) {
				$variationImage.closest('.piotnetgrid-image').removeClass('piotnetgrid-image-variation-selected');
			}

			if ($addToCartButtonAjax.length > 0) {
				$addToCartButtonAjax.attr('data-piotnetgrid-atc-product-variation', '');
			}

			if ($variationPrice.length > 0) {
				$variationPrice.removeClass('active');
				$card.find('.piotnetgrid-wc-price').removeClass('inactive');
			}
		}
	});

	$(document).on('click', '[data-piotnetgrid-atc-product-id]', function() {
		var product_id = $(this).attr('data-piotnetgrid-atc-product-id'),
			quantity = $(this).attr('data-piotnetgrid-atc-product-quantity'),
			variationProduct = $(this).attr('data-piotnetgrid-atc-product-variation') !== undefined ? true : false,
			$card = $(this).closest('.piotnetgrid-card'),
			variations = {},
			$button = $(this),
			$buttonWrapper = $(this).closest('.piotnetgrid-button-atc');

		$card.find('[data-piotnetgrid-variation-swatches-attribute-field]:checked, select[data-piotnetgrid-variation-swatches-attribute-field]').each(function(){
			variations[$(this).attr('name')] = $(this).val();
		});

		var data = {
			action: 'piotnetgrid_add_to_cart',
			product_id: product_id,
			quantity: quantity
		}

		if (variationProduct) {
			data.variation_id = $(this).attr('data-piotnetgrid-atc-product-variation');
 			data.variations = variations;
		}

		$.post(ajaxurl, data, function(response) {
			$button.removeClass('piotnetgrid-loading');
			$buttonWrapper.addClass('piotnetgrid-button-atc--added');
			if ($button.closest('.piotnetgrid-grid--masonry').length > 0) {
				window.piotnetgridMasonryLayout($button.closest('.piotnetgrid-grid--masonry'));
			}
			$( document.body ).trigger( 'added_to_cart', [ response.fragments, response.cart_hash ] );
		});
	});
});