<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

	add_action( 'wp_ajax_piotnetgrid_add_to_cart', 'piotnetgrid_add_to_cart' );
	add_action( 'wp_ajax_nopriv_piotnetgrid_add_to_cart', 'piotnetgrid_add_to_cart' );

	function piotnetgrid_add_to_cart() {
		$product_id        = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
	    $quantity          = empty( $_POST['quantity'] ) ? 1 : wc_stock_amount( $_POST['quantity'] );

	    if (isset($_POST['variation_id'])) {
		    $variation_id      = isset( $_POST['variation_id'] ) ? absint( $_POST['variation_id'] ) : '';
		    $variations         = ! empty( $_POST['variations'] ) ? (array) $_POST['variations'] : '';

		    $passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity, $variation_id, $variations );

		    if ( $passed_validation && WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variations ) ) {

		        do_action( 'woocommerce_ajax_added_to_cart', $product_id );

		        if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
		            wc_add_to_cart_message( $product_id );
		        }

		        // Return fragments
		        WC_AJAX::get_refreshed_fragments();

		    } else {

		        // If there was an error adding to the cart, redirect to the product page to show any errors
		        $data = array(
		            'error' => true,
		            'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
		        );

		        wp_send_json( $data );

		    }
	    } else {
	    	if ( WC()->cart->add_to_cart( $product_id, $quantity ) ) {

		        do_action( 'woocommerce_ajax_added_to_cart', $product_id );

		        if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
		            wc_add_to_cart_message( $product_id );
		        }

		        // Return fragments
		        WC_AJAX::get_refreshed_fragments();

		    } else {

		        // If there was an error adding to the cart, redirect to the product page to show any errors
		        $data = array(
		            'error' => true,
		            'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
		        );

		        wp_send_json( $data );

		    }
	    }

		wp_die();
	}