<?php
	if ( ! defined( 'ABSPATH' ) ) { exit; }

	add_action( 'wp_ajax_piotnetgrid_check_facet_name', 'piotnetgrid_check_facet_name' );
	add_action( 'wp_ajax_nopriv_piotnetgrid_check_facet_name', 'piotnetgrid_check_facet_name' );

	function piotnetgrid_check_facet_name() {
		if (!empty($_POST['facet_name'])) {
			$facet_name = $_POST['facet_name'];
			$facet_settings = get_option( '_piotnetgrid_facet_' . $facet_name );
			if (!empty($facet_settings)) {
				$facet_settings = json_decode( stripslashes( $facet_settings ), true );
				$post_id = !empty($facet_settings['post_id']) ? $facet_settings['post_id'] : '';
				$widget_id = !empty($facet_settings['widget_id']) ? $facet_settings['widget_id'] : 'piotnetgrid';
				$raw_data = json_decode(get_post_meta( $post_id, '_piotnetgrid_data', true ), true);

				if ($widget_id != $_POST['widget_id'] && isset($raw_data['widgets'][$widget_id])) {
					$response = '<div class="piotnetgrid-control__alert" data-piotnetgrid-control-alert>This Facet Name was used at <a href="' . get_admin_url( null, 'admin.php?page=piotnetgrid&post=' ) . $post_id . '" target="_blank"><strong>HERE</strong></a> . Please change your Facet Name</div>';
					echo $response;
				}
			}
		}
		wp_die();
	}
