<?php
	if ( ! defined( 'ABSPATH' ) ) { exit; }

	function piotnetgrid_facet($data) {
		$response = [];
		$cache_enable = $data->get_param('cache_enable');
		$cache_expiration = $data->get_param('cache_expiration');
		$request_url = $data->get_param('request_url');
		$grid_post_id = $data->get_param('grid_post_id');
		$cache_file = piotnetgrid_get_cache($request_url, $grid_post_id);
		$post_types = get_post_types();
		$piotnetgrid = $data->get_param('piotnetgrid');
		global $wpdb;

		if (!empty($cache_file) && $cache_enable == 'true') {
			$cache_url = WP_CONTENT_DIR . '/cache/piotnetgrid/json/' . $cache_file;
			$response['widgets'] = @json_decode(file_get_contents($cache_url), true);
		} else {
			$grid_ids = $data->get_param('grid_ids');
			$facets = $data->get_param('facets');
			$facets_has_value_count = 0;
			$facets_has_value = [];
			$facets_has_value_ids = [];
			$facet_current_id = $data->get_param('facet_current_id');
			$facet_current_type = $data->get_param('facet_current_type');
			$firstload = $data->get_param('firstload') == 'true' ? true : false;
			$post_ids_for_facets = [];
			$post_ids_count = 0;
			$current_query = !empty($data->get_param('current_query')) ? json_decode(stripslashes($data->get_param('current_query')), true) : [];
			$current_url_path = $data->get_param('current_url_path');
			$lang = $data->get_param('lang');
			$paged = 1;
			$posts_per_page = get_option( 'posts_per_page' );

			$args_additional = [
				'query' => $current_query,
				'current_query' => $current_query,
				'piotnetgrid' => $piotnetgrid,
			];

			if (!empty($facets)) {
				foreach ($facets as $facets_post_id => $facets_list) {
					foreach ($facets_list as $facet) {
						$facet_value = !empty($facet['value']) ? $facet['value'] : '';
						if (!empty($facet_value)) {
							$facets_has_value_count++;

							if ($facet['action'] !== 'load') {
								$facets_has_value[] = array( 
									'facet_name' => $facet['name'],
									'facet_value' => is_array($facet['value']) ? implode(',', $facet['value']) : $facet['value'],
									'facet_value_label' => is_array($facet['value_label']) ? implode(',', $facet['value_label']) : $facet['value_label'],
									'facet_label' => !empty($facet['label']) ? $facet['label'] : '',
								);
								$facets_has_value_ids[] = $facet['id'];
							}
						}
					}

					$args_additional = piotnetgrid_facet_change_query($facets_list, $args_additional);
				}
			}

			if ($facet_current_type != 'pagination' && $facet_current_type != 'load_more' && !$firstload) {
				unset($args_additional['query']['paged']);
			}
			
			$no_results = false;

			foreach ($grid_ids as $grid_id) {
				if (!empty($lang)) {
					$args_additional['lang'] = $lang;
				}

				if ( $piotnetgrid == 'true' ) {
					$data     = json_decode( get_post_meta( $grid_post_id, '_piotnetgrid_data', true ), true );
					$widgets  = $data['widgets'];
					$settings = $widgets[ $grid_id ]['settings'];
					$widget = new piotnetgrid_Grid();
					$widget->settings  = $settings;
					$widget->widget_id = $grid_id;

					$response['widgets'][$grid_id]['outputHTML'] = $widget->output( $grid_id, false, $args_additional );
					if (empty($widget->post_ids) && !$no_results) {
						$no_results = true;
					}

					$post_ids_count = count($widget->post_ids);
					$paged = $widget->paged;
					$posts_per_page = $widget->posts_per_page;

					$args_additional_current_query = [];
					if (!empty($args_additional['current_query'])) {
						$args_additional_current_query['current_query'] = $args_additional['current_query'];
						$args_additional_current_query['query'] = $args_additional['current_query'];
					}
					$widget_not_facets = $widget->set_query( $settings, $args_additional_current_query, true, $lang );
					$post_ids_not_facets = $widget->post_ids;
				} else {
					foreach ($args_additional['current_query'] as $key => $value) {
						if (isset($args_additional['query'][$key])) {
							if (is_array($value) && $args_additional['query'][$key] !== $value) {
								$args_additional['query'][$key] = array_merge_recursive($args_additional['query'][$key],$value);
							}
						} else {
							$args_additional['query'][$key] = $value;
						}
					}

					unset($args_additional['query']['number']);
					$query_not_piotnetgrid_args = $args_additional['query'];
					$query_not_piotnetgrid_args['fields'] = 'ids';
					$query_not_piotnetgrid_args['posts_per_page'] = '100000000';
					$query_not_piotnetgrid = new WP_Query($query_not_piotnetgrid_args);

					$query_not_piotnetgrid_args_not_facets = $args_additional['current_query'];
					$query_not_piotnetgrid_args_not_facets['fields'] = 'ids';
					$query_not_piotnetgrid_args_not_facets['posts_per_page'] = '100000000';
					$query_not_piotnetgrid_not_facets = new WP_Query($query_not_piotnetgrid_args_not_facets);

					$query_not_piotnetgrid_intersect = array_intersect($query_not_piotnetgrid->posts, $query_not_piotnetgrid_not_facets->posts);

					$query_not_piotnetgrid_post_data_args = $args_additional['query'];
					$query_not_piotnetgrid_post_data_args['post__in'] = $query_not_piotnetgrid_intersect;

					$get_page_html_post_data = http_build_query(
					    array(
					        'get_posts_query' => json_encode($query_not_piotnetgrid_post_data_args),
					    )
					);

					$get_page_html_opts = array(
						'http' => array(
					        'method'  => 'POST',
					        'header'  => 'Content-Type: application/x-www-form-urlencoded',
					        'content' => $get_page_html_post_data
					    ),
					);

					$get_page_html_context  = stream_context_create($get_page_html_opts);
					$get_page_html = file_get_contents(get_site_url() . $request_url, false, $get_page_html_context);

					$response['widgets'][$grid_id]['outputHTML'] = $get_page_html;

					$post_ids_not_facets = $query_not_piotnetgrid_not_facets->posts;
				}

				if (!empty($facets)) {
					$facets_array = [];
					foreach ($facets as $facets_post_id => $facets_list) {
						foreach ($facets_list as $facet) {
							$facets_array[] = $facet;
						}
					}

					foreach ($facets_array as $facet) {
						$args_additional_for_facet = [
							'query' => $current_query,
							'current_query' => $current_query,
						];

						if (isset($query_not_piotnetgrid_intersect)) {
							$args_additional_for_facet['query']['post__in'] = $query_not_piotnetgrid_not_facets->posts;
						}

						$args_additional_for_facet = piotnetgrid_facet_change_query($facets_array, $args_additional_for_facet, $facet['id']);

						if ( $piotnetgrid == 'true' ) {
							$widget->set_query( $settings, $args_additional_for_facet, true, $lang );
							$post_ids_for_facets[$facet['id']] = $widget->post_ids;
						} else {
							$args_additional_for_facet['query']['fields'] = 'ids';
							$args_additional_for_facet['query']['posts_per_page'] = '100000000';
							$query_not_piotnetgrid_facet = new WP_Query($args_additional_for_facet['query']);
							$post_ids_for_facets[$facet['id']] = $query_not_piotnetgrid_facet->posts;
						}
					}
				}
			}

			$current_time = date('Y-m-d H:i:s');

			if (!empty($facets)) {

				$table_name = $wpdb->prefix . 'piotnetgrid_analytics';

				foreach ($facets as $facets_post_id => $facets_list) {
					$facets_post_data = json_decode( get_post_meta( $facets_post_id, '_piotnetgrid_data', true ), true );
					$facets_widgets  = $facets_post_data['widgets'];
					foreach ($facets_list as $facet) {

						if ($facet_current_id == $facet['id'] || $facet_current_id != $facet['id'] && !in_array($facet_current_id, $facets_has_value_ids)) {
							$facet_value = !empty($facet['value']) ? $facet['value'] : '';
							if (!empty($facet_value)) {
								if ($facet['action'] !== 'load') {
									if (is_array($facet['value'])) {
										foreach ($facet['value'] as $facet_value_key => $facet_value_item) {
											$wpdb->insert( 
												$table_name, 
												array( 
													'facet_name' => $facet['name'],
													'facet_value' => $facet_value_item,
													'facet_value_label' => is_array($facet['value_label']) ? $facet['value_label'][$facet_value_key] : $facet['value_label'],
													'facet_label' => !empty($facet['label']) ? $facet['label'] : '',
													'url' => $current_url_path,
													'grouped' => false,
													'no_results' => $facets_has_value_count == 1 ? $no_results : false,
													'time' => $current_time,
												) 
											);
										}
									} else {
										$wpdb->insert( 
											$table_name, 
											array( 
												'facet_name' => $facet['name'],
												'facet_value' => $facet['value'],
												'facet_value_label' => $facet['value_label'],
												'facet_label' => !empty($facet['label']) ? $facet['label'] : '',
												'url' => $current_url_path,
												'grouped' => false,
												'no_results' => $facets_has_value_count == 1 ? $no_results : false,
												'time' => $current_time,
											) 
										);
									}
								}
							}
						}

						if ($facet_current_id == $facet['id'] && $facet_current_type != 'slider' || $facet_current_id != $facet['id'] || $facet_current_type == 'pagination' || $facet_current_type == 'load_more' || $firstload == 'true') {
							$facet_options = [];
							$settings = $facets_widgets[ $facet['id'] ]['settings'];
							$widget = new piotnetgrid_Facet();
							$widget->settings  = $settings;
							$widget->widget_id = $facet['id'];
							$args_additional_facet = [];
							$args_additional_facet['query'] = $args_additional['query'];
							$args_additional_facet['value'] = !empty($facet['value']) ? $facet['value'] : '';
							$args_additional_facet['grid'] = $grid_post_id;
							$args_additional_facet['exclude_terms'] = !empty($facet['exclude_terms']) ? $facet['exclude_terms'] : [];
							$args_additional_facet['facet_current_type'] = $facet_current_type;

							if ($facets_has_value_count >= 1) {
								$post_ids = $post_ids_for_facets[$facet['id']];
							} else {
								$post_ids = $post_ids_not_facets;
							}

							$args_additional_facet['post_ids'] = $post_ids;

							if ($facet_current_type != 'pagination' && $facet_current_type != 'load_more') {
								if (!empty($facet['filter_source'])) {
									switch ($facet['filter_source']) {
										case 'taxonomy':
											if (!empty($settings['filter_data_source_taxonomy'])) {
												$terms = get_terms( array(
												    'taxonomy' => $settings['filter_data_source_taxonomy'],
												    'hide_empty' => false,
												) );

												foreach ($terms as $term) {
													$term_count = 0;

													if (is_object($term)) {
														if (!empty($post_ids)) {

															$post_ids_outofstock = piotnetgrid_get_product_variation_out_of_stock($settings['filter_data_source_taxonomy'], $term->slug);
															$post_ids_for_term = $post_ids;

															if (!empty($post_ids_outofstock)) {
																foreach ($post_ids_for_term as $key => $value) {
																	if (in_array($value, $post_ids_outofstock)) {
																		unset($post_ids_for_term[$key]);
																	}
																}
															}
										
															$term_query = new WP_Query( array(
																'post_type' => $post_types,
														        'post__in' =>  $post_ids_for_term,
														        'posts_per_page' => -1,
														        'tax_query' => array(
															        array(
															            'taxonomy' => $facet['filter_taxonomy'],
															            'field'    => 'slug',
															            'terms'    => $term->slug,
															            'include_children' => false,
															        ),
															    ),
														    ));
														    $term_count = $term_query->post_count;
														} else {
															$term_count = 0;
														}

														$facet_option = [
															'value' => $term->slug,
															'label' => $term->name,
															'count' => $term_count,
														];

														if ($settings['filter_type'] == 'color-picker') {
															$facet_option['color'] = '#' . get_term_meta( $term->term_id, 'piotnetgrid_term_color', true );
														}

														if ($settings['filter_type'] == 'image-select') {
															$facet_option['image'] = '';
															$term_image_id = get_term_meta( $term->term_id, 'piotnetgrid_term_image', true );
															if (!empty($term_image_id)) {
																$facet_option['image'] = wp_get_attachment_image_src( $term_image_id, 'full' )[0];
															}
														}

														$facet_options[] = $facet_option;
													}
												}

												$args_additional_facet['facet_options'] = $facet_options;
												$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

												break;
											}

										case 'custom_field':
											if (!empty($settings['filter_data_source_custom_field'])) {
												$filter_custom_field_name = $settings['filter_data_source_custom_field'];
												if (!empty($filter_custom_field_name)) {
													$post_ids_for_custom_field = !empty($post_ids) ? $post_ids : $post_ids_not_facets;
													if (!empty($post_ids_for_custom_field)) {
														$post_ids_in = '(' . implode(',', $post_ids_for_custom_field) .')';
														$filter_custom_field_checkbox = false;

														if ( strpos( $filter_custom_field_name, 'acf/' ) !== false && function_exists('acf_get_field_groups') ) {
															$acf_field_key = str_replace('acf/', '', $filter_custom_field_name);
															$acf_field_object = get_field_object($acf_field_key);
															$acf_field_name = $acf_field_object['name'];
															$filter_custom_field_name = $acf_field_name;

															if (in_array($acf_field_object['type'], ['checkbox','select','radio','button_group'])) {
																$filter_custom_field_checkbox = true;
																$facet_options = [];
																foreach ($acf_field_object['choices'] as $key => $value) {
																	$facet_option = [
																		'value' => $key,
																		'label' => $value,
																		'count' => 0,
																	];

																	$facet_option_value = $acf_field_object['type'] == 'select' && $acf_field_object['multiple'] != 1 || $acf_field_object['type'] == 'radio' ? $key : '"' . $key . '"';

																	$facet_option_compare = $acf_field_object['type'] == 'select' && $acf_field_object['multiple'] != 1 || $acf_field_object['type'] == 'radio' ? '=' : 'LIKE';

																	$facet_option_query = new WP_Query( array(
																		'post_type' => $post_types,
																		'post__in' => $post_ids_for_custom_field,
																		'posts_per_page' => -1,
																		'fields' => 'ids',
																		'meta_query' => array(
																			array(
																				'key'		=> $acf_field_name,
																				'value'		=> $facet_option_value,
																				'compare'	=> $facet_option_compare
																			),
																		)
																	) );

																	$facet_option['count'] = $facet_option_query->found_posts;

																	$facet_options[] = $facet_option;
																}
															}
														}

                                                        if ( strpos( $filter_custom_field_name, 'metabox/' ) !== false && function_exists('rwmb_meta') ) {
                                                            $metabox_field_key = str_replace('metabox/', '', $filter_custom_field_name);
                                                            $metabox_field_ids = array();
                                                            $agrs = array( 'post_type' => 'meta-box' );
                                                            $metabox_field_query = new WP_query($agrs);
                                                            if ( $metabox_field_query->have_posts() ) {
                                                                while ( $metabox_field_query->have_posts() ) {
                                                                    $metabox_field_query->the_post();
                                                                    $metabox_field_ids[] = get_the_ID();
                                                                }
                                                            }
                                                            foreach ( $metabox_field_ids as $metabox_field_id ) {
                                                                $metabox_field_group = rwmb_meta('meta_box', array(), $metabox_field_id);
                                                                foreach ( $metabox_field_group['fields'] as $metabox_fields ) {
                                                                    if ($metabox_fields['id'] == $metabox_field_key) {
                                                                        $metabox_field_name = $metabox_fields['id'];
                                                                        $filter_custom_field_name = $metabox_field_name;
                                                                        if (in_array($metabox_fields['type'], ['checkbox_list', 'select', 'radio', 'button_group'])) {
                                                                            $filter_custom_field_checkbox = true;
                                                                            foreach ($metabox_fields['options'] as $key => $value) {
                                                                                $facet_option = [
                                                                                    'value' => $key,
                                                                                    'label' => $value,
                                                                                    'count' => 0,
                                                                                ];

                                                                                $facet_option_query = new WP_Query( array(
                                                                                    'post_type' => $post_types,
                                                                                    'post__in' => $post_ids_for_custom_field,
                                                                                    'posts_per_page' => -1,
                                                                                    'fields' => 'ids',
                                                                                    'meta_query' => array(
                                                                                        array(
                                                                                            'key'		=> $metabox_field_name,
                                                                                            'value'		=> $key,
                                                                                            'compare'	=> '='
                                                                                        ),
                                                                                    )
                                                                                ) );

                                                                                $facet_option['count'] = $facet_option_query->found_posts;

                                                                                $facet_options[] = $facet_option;
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }

                                                        if ( strpos( $filter_custom_field_name, 'jetengine/' ) !== false && function_exists('jet_engine') ) {
                                                            $jetengine_field_key = str_replace('jetengine/', '', $filter_custom_field_name);
                                                            $jetengine_field_groups = get_option('jet_engine_meta_boxes');
                                                            foreach ( $jetengine_field_groups as $jetengine_field_group ) {
                                                                $jetengine_fields = $jetengine_field_group['meta_fields'];
                                                                foreach ( $jetengine_fields as $jetengine_field ) {
                                                                    if ( ($jetengine_field['name'] == $jetengine_field_key) ) {
                                                                        $jetengine_field_name = $jetengine_field['name'];
                                                                        $filter_custom_field_name = $jetengine_field_name;

                                                                        if (in_array($jetengine_field['type'], ['checkbox','select','radio'])) {
                                                                            $filter_custom_field_checkbox = true;
                                                                            foreach ($jetengine_field['options']  as $value) {
                                                                                $facet_option = [
                                                                                    'value' => $value['key'],
                                                                                    'label' => $value['value'],
                                                                                    'count' => 0,
                                                                                ];

                                                                                $facet_option_value = $jetengine_field['type'] == 'select' || $jetengine_field['type'] == 'radio' ? $value['key'] : '"' . $value['key'] . '"' . ';s:4:"true';

                                                                                $facet_option_compare = $jetengine_field['type'] == 'select' && !$jetengine_field['is_multiple'] || $jetengine_field['type'] == 'radio' ? '=' : 'LIKE';

                                                                                $facet_option_query = new WP_Query( array(
                                                                                    'post_type' => $post_types,
                                                                                    'post__in' => $post_ids_for_custom_field,
                                                                                    'posts_per_page' => -1,
                                                                                    'fields' => 'ids',
                                                                                    'meta_query' => array(
                                                                                        array(
                                                                                            'key'		=> $jetengine_field_name,
                                                                                            'value'		=> $facet_option_value,
                                                                                            'compare'	=> $facet_option_compare
                                                                                        ),
                                                                                    )
                                                                                ) );

                                                                                $facet_option['count'] = $facet_option_query->found_posts;

                                                                                $facet_options[] = $facet_option;
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
													}

													if (!$filter_custom_field_checkbox) {
														$filter_custom_field_values = $wpdb->get_results( 'SELECT meta_value AS "value", meta_value AS "label", count(*) AS "count" FROM ' . $wpdb->prefix . 'postmeta WHERE post_id IN ' . $post_ids_in . ' AND meta_key = "' . $filter_custom_field_name . '" AND meta_value <> "" GROUP BY meta_value', ARRAY_A );
														$facet_options = $filter_custom_field_values;

														if (empty($filter_custom_field_values)) {
															$post_ids_in = '(' . implode(',', $post_ids_not_facets) .')';
															$filter_custom_field_values = $wpdb->get_results( 'SELECT meta_value AS "value", count(*) AS "count" FROM ' . $wpdb->prefix . 'postmeta WHERE post_id IN ' . $post_ids_in . ' AND meta_key = "' . $filter_custom_field_name . '" AND meta_value <> "" GROUP BY meta_value', ARRAY_A );

															foreach ($filter_custom_field_values as $filter_custom_field_value) {
																$facet_options[] = [
																	'value' => $filter_custom_field_value['value'],
																	'label' => $filter_custom_field_value['value'],
																	'count' => 0,
																];
															}
														}
													}

													$args_additional_facet['facet_options'] = $facet_options;
													$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );
												}
											}

											break;

										case 'post_date':
											$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );
											break;

										case 'author':
											$authors = [];

											foreach ($post_ids_not_facets as $post_id) {
												$author_id = get_post_field( 'post_author', $post_id );
												$author = get_user_by( 'ID', $author_id );
												$authors[$author_id]['name'] = $author->display_name; 
											}

											foreach ($authors as $key => $author) {
												if (!empty($post_ids)) {
													$author_query = new WP_Query( array(
														'post_type' => $post_types,
												        'post__in' => $post_ids,
												        'posts_per_page' => -1,
												        'author' => $key,
												    ));
												}
												
											    $facet_options[] = [
													'value' => $key,
													'label' => $authors[$key]['name'],
													'count' => !empty($post_ids) ? $author_query->post_count : 0,
												];
											}

											$args_additional_facet['facet_options'] = $facet_options;
											$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

											break;

                                        case 'az':

                                            $az_list = $facet['az_list'];

                                            foreach ($az_list as $az_text) {
                                                $az_query = new WP_Query( array(
                                                    'post_type' => $post_types,
                                                    'post__in' =>  $post_ids,
                                                    'posts_per_page' => -1,
                                                    'piotnetgrid_query_starts_with' => $az_text,
                                                    'fields' => 'ids',
                                                ));
                                                $facet_options[] = [
                                                    'value' => $az_text,
                                                    'label' => $az_text,
                                                    'count' => count($az_query->posts),
                                                ];
                                            }

                                            $args_additional_facet['facet_options'] = $facet_options;
											$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

                                            break;
									}
								}
							}

							if (!empty($facet['loading_type'])) {
								switch ($facet['loading_type']) {
									case 'pagination':

										if ($facet_current_type != 'pagination' && !$firstload) {
											$args_additional_facet['value'] = '';
										}

										$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

										break;

									case 'load_more':
										$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

										break;

									case 'result_counts':
										$response['widgets'][$facet['id']]['outputHTML'] = stripslashes( $widget->output( $facet['id'], false, $args_additional_facet ) );

										break;
								}
							}
						}
					}
				}

				if (!empty($facets_has_value)) {
					if (count($facets_has_value) > 1) {
						array_multisort( array_column( $facets_has_value, 'facet_name' ), SORT_ASC, SORT_STRING, $facets_has_value );
						
						$grouped_facet_name = [];
						$grouped_facet_value = [];
						$grouped_facet_value_label = [];
						$grouped_facet_label = [];

						foreach ($facets_has_value as $facets_has_value_item) {
							$grouped_facet_name[] = $facets_has_value_item['facet_name'];
							$grouped_facet_value[] = $facets_has_value_item['facet_value'];
							$grouped_facet_value_label[] = $facets_has_value_item['facet_value_label'];
							$grouped_facet_label[] = $facets_has_value_item['facet_label'];
						}

						$wpdb->insert( 
							$table_name, 
							array(
								'facet_name' => json_encode($grouped_facet_name, JSON_UNESCAPED_UNICODE),
								'facet_value' => json_encode($grouped_facet_value, JSON_UNESCAPED_UNICODE),
								'facet_value_label' => json_encode($grouped_facet_value_label, JSON_UNESCAPED_UNICODE),
								'facet_label' => json_encode($grouped_facet_label, JSON_UNESCAPED_UNICODE),
								'url' => $current_url_path,
								'grouped' => true,
								'no_results' => $no_results,
								'time' => $current_time,
							) 
						);
					}
				}
			}

			if ($cache_enable == 'true') {
				$cache_id = piotnetgrid_set_cache($request_url, $current_url_path, $cache_expiration, $grid_post_id);
				if ( is_dir( WP_CONTENT_DIR . '/cache/piotnetgrid/json' ) ) {
					$cache_file = piotnetgrid_get_cache($request_url, $grid_post_id);
					$cache_url = WP_CONTENT_DIR . '/cache/piotnetgrid/json/' . $cache_file;
					@file_put_contents( $cache_url, json_encode($response['widgets'], JSON_UNESCAPED_UNICODE) );
					$response['cache_file'] = str_replace('.json', '', $cache_file);
				}
			}
		}

		$response = json_encode($response, JSON_UNESCAPED_UNICODE);

		return $response;

		wp_die();
	}
