<?php
	if ( ! defined( 'ABSPATH' ) ) { exit; }
	add_action( 'wp_ajax_piotnetgrid_save', 'piotnetgrid_save' );
	add_action( 'wp_ajax_nopriv_piotnetgrid_save', 'piotnetgrid_save' );

	const DATA_VERSION_PIOTNETGRID = 1;

	function piotnetgrid_save() {

		$post_id = $_POST['post_id'];

		if ( ! is_user_logged_in() || ! current_user_can( 'edit_others_posts' ) ) {
			print_r( 'permission_error' );
			return;
		}

		print_r( $post_id );

		if ( isset( $_POST['piotnetgrid_data'] ) ) {
			$raw_data = stripslashes( $_POST['piotnetgrid_data'] );
			$data = json_decode( $raw_data );
			$data_array = json_decode( $raw_data, true );

			foreach ($data_array['widgets'] as $widget_id => $widget) {
				if ($widget['type'] == 'facet') {
					$widget['settings']['post_id'] = $post_id;
					$widget['settings']['widget_id'] = $widget_id;
					$facet_settings = json_encode( $widget['settings'] );
					update_option( '_piotnetgrid_facet_' . $widget['settings']['facet_name'], wp_slash( $facet_settings ) );
				}
			}

			if ( function_exists('icl_object_id') ) {
				global $wpdb;
		
				foreach ($data_array['widgets'] as $widget_item) {
					if (!empty($widget_item['class_name'])) {
						$widget = new $widget_item['class_name'];

						if (method_exists($widget,'multilingual_fields')) {
							$multilingual_fields = $widget->multilingual_fields();
							foreach ($multilingual_fields as $multilingual_field) {
								$multilingual_field_name = $multilingual_field['field'];
								$multilingual_field_value = !empty($widget_item['settings'][$multilingual_field_name]) ? $widget_item['settings'][$multilingual_field_name] : '';
								if (!empty($multilingual_field_value)) {
									$multilingual_field_translation = @$wpdb->get_results( 'SELECT id FROM ' . $wpdb->prefix . 'icl_strings WHERE value = "' . $multilingual_field_value . '" AND context = "piotnetgrid"', ARRAY_A );
									if (count($multilingual_field_translation) == 0) {
									   @$wpdb->insert( 
											$wpdb->prefix . 'icl_strings',
											array( 
												'language' => 'en',
												'context' => 'piotnetgrid',
												'name' => md5($multilingual_field_value),
												'value' => $multilingual_field_value,
												'type' => $multilingual_field['editor_type'],
												'domain_name_context_md5' => md5( 'piotnetgrid' . md5($multilingual_field_value) ),
											) 
										);
									}
								}
							}
						}
					}
				}
			}

			$data->version = DATA_VERSION_PIOTNETGRID;
			$data_str = json_encode( $data );
			update_post_meta( $post_id, '_piotnetgrid_data', wp_slash( $data_str ) );

			if (isset($_POST['piotnetgrid_global_settings'])) {
				$raw_global_settings = stripslashes( $_POST['piotnetgrid_global_settings'] );
				update_option( 'piotnetgrid_global_settings', wp_slash( $raw_global_settings ) );
			}

			if (isset($_POST['piotnetgrid_single_settings'])) {
				$raw_single_settings = stripslashes( $_POST['piotnetgrid_single_settings'] );
				update_post_meta( $post_id, '_piotnetgrid_single_settings', wp_slash( $raw_single_settings ) );
			}
		}

		if ( isset( $_POST['piotnetgrid-widgets-css'] ) ) {
			$widgets_css      = $_POST['piotnetgrid-widgets-css'];
			$revision_version = intval( get_post_meta( $post_id, '_piotnetgrid-revision-version', true ) ) + 1;
			update_post_meta( $post_id, '_piotnetgrid-revision-version', $revision_version );

			$upload     = wp_upload_dir();
			$upload_dir = $upload['basedir'];
			$upload_dir = $upload_dir . '/piotnetgrid/css/';

			$file = fopen( $upload_dir . $post_id . '.css', 'wb' );
			fwrite( $file, stripslashes( $widgets_css ) );
			fclose( $file );

			if (isset($_POST['piotnetgrid-global-css'])) {
				$global_css      = $_POST['piotnetgrid-global-css'];
				$global_css_version = intval( get_option( 'piotnetgrid-global-css-version' ) ) + 1;
				update_option( 'piotnetgrid-global-css-version', $global_css_version );
				$file = fopen( $upload_dir . 'global.css', 'wb' );
				fwrite( $file, stripslashes( $global_css ) );
				fclose( $file );
			}
		}

		$post_title = get_the_title($post_id);

		$my_post_update = [
			'ID'          => $post_id,
			'post_title'  => ! empty( $post_title ) ? $post_title : ( 'Piotnet Grid #' . $post_id ),
			'post_status' => 'publish',
		];
		wp_update_post( $my_post_update );

		update_post_meta( $post_id, '_piotnetgrid_form_id', get_the_title($post_id) );

		wp_die();
	}
