<?php
	if ( ! defined( 'ABSPATH' ) ) { exit; }
	add_action( 'wp_ajax_piotnetgrid_select_autocomplete', 'piotnetgrid_select_autocomplete' );
	add_action( 'wp_ajax_nopriv_piotnetgrid_select_autocomplete', 'piotnetgrid_select_autocomplete' );

	function piotnetgrid_select_autocomplete() {
		$return = array();
 		$function = $_POST['function'];
 		$query = $_POST['query'];

 		switch ($query) {
 			case 'posts':
 				switch ($function) {
 					case 'init':
	 					if (!empty($_POST['options'])) {
	 						foreach ($_POST['options'] as $post_id) {
	 							$post_title = get_the_title($post_id);
								$post_title_additional = ' (ID ' . $post_id . ')';
								$title = ( mb_strlen( $post_title ) > 30 ) ? mb_substr( $post_title, 0, 29 ) . '...' . $post_title_additional : $post_title . $post_title_additional;
	 							$return[$post_id] = $title;
	 						}
	 					}

 						break;
 					
 					case 'search':
 						$search_results = new WP_Query( array( 
 							'post_type' => 'any',
							's' => $_POST['search'],
							'ignore_sticky_posts' => 1,
							'posts_per_page' => 50
						) );

						if( $search_results->have_posts() ) :
							while( $search_results->have_posts() ) : $search_results->the_post();
								$post_title = $search_results->post->post_title;
								$post_title_additional = ' (ID ' . get_the_ID() . ')';
								$title = ( mb_strlen( $post_title ) > 30 ) ? mb_substr( $post_title, 0, 29 ) . '...' . $post_title_additional : $post_title . $post_title_additional;
								$return[] = array( $search_results->post->ID, $title );
							endwhile;
						endif;

 						break;
 				}
 				
 				break;

			case 'terms':
 				switch ($function) {
 					case 'init':
 						if (!empty($_POST['options'])) {
	 						foreach ($_POST['options'] as $term_id) {
	 							$term = get_term($term_id);
	 							$term_title = $term->name;
								$term_title_additional = ' (ID ' . $term_id . ')' . ' - ' . $term->taxonomy;
								$title = ( mb_strlen( $term_title ) > 30 ) ? mb_substr( $term_title, 0, 29 ) . '...' . $term_title_additional : $term_title . $term_title_additional;
	 							$return[$term_id] = $title;
	 						}
 						}

 						break;
 					
 					case 'search':
 						$terms = get_terms( array(
						    'name__like' =>  $_POST['search'],
						) );

 						foreach ($terms as $term) {
 							$term_title = $term->name;
							$term_title_additional = ' (ID ' . $term->term_id . ')' . ' - ' . $term->taxonomy;
							$title = ( mb_strlen( $term_title ) > 30 ) ? mb_substr( $term_title, 0, 29 ) . '...' . $term_title_additional : $term_title . $term_title_additional;
							$return[] = array( $term->term_id, $title );
 						}

 						break;
 				}
 				
 				break;

			case 'custom_field':
 				switch ($function) {
 					case 'init':

						if (!empty($_POST['options'])) {
							$custom_field_name = $_POST['options'][0];
							if ( strpos( $custom_field_name, 'acf/' ) !== false && function_exists('acf_get_field_groups') ) {
		 						$field_groups = acf_get_field_groups();

								foreach ( $field_groups as $field_group ) {
									$fields = acf_get_fields( $field_group );
									foreach ($fields as $field) {
										if ( 'acf/' . $field['key'] == $custom_field_name ) {
											$return[$custom_field_name] = 'ACF > ' . $field_group['title'] . ' > ' . $field['label'];
										}
									}
								}
							} else {
								$return[$custom_field_name] = $custom_field_name;
							}

                            if ( strpos( $custom_field_name, 'metabox/' ) !== false && function_exists('rwmb_meta') ) {
                                $agrs = array( 'post_type' => 'meta-box', 'fields' => 'ids' );
                                $query = new WP_query($agrs);
                                $field_ids = $query->posts;

                                foreach ( $field_ids as $field_id ) {
                                    $field_group = rwmb_meta('meta_box', array(), $field_id);
                                    if ( !empty($field_group) ) {
                                        $fields = $field_group['fields'];
                                        foreach ($fields as $field) {
                                            if ( 'metabox/' . $field['id'] == $custom_field_name )
                                            $return[$custom_field_name] = 'METABOX > ' . $field_group['title'] . ' > ' . $field['name'];
                                        }
                                    }
                                }
                            }

                            if ( strpos( $custom_field_name, 'jetengine/' ) !== false && function_exists('jet_engine') ) {
                                $field_groups = get_option('jet_engine_meta_boxes');
                                if ( !empty($field_groups) ) {
                                    foreach ( $field_groups as $field_group ) {
                                        $fields = $field_group['meta_fields'];
                                        foreach ( $fields as $field ) {
                                            if ( 'jetengine/' . $field['name'] == $custom_field_name ) {
                                                $return[$custom_field_name] = 'JetEngine > ' . $field_group['args']['name'] . ' > ' . $field['title'];
                                            }
                                        }
                                    }
                                }
                            }
	 					}

 						break;
 					
 					case 'search':

	 					if (function_exists('acf_get_field_groups')) {
	 						$field_groups = acf_get_field_groups();

							foreach ( $field_groups as $field_group ) {
								$fields = acf_get_fields( $field_group );
								foreach ($fields as $field) {
									if ( strpos( $field['name'], $_POST['search'] ) !== false ) {
										$return[] = array( 'acf/' . $field['key'], 'ACF > ' . $field_group['title'] . ' > ' . $field['label'] );
									}
								}
							}
	 					}

                        if (function_exists('rwmb_meta')) {
                            $agrs = array( 'post_type' => 'meta-box', 'fields' => 'ids' );
                            $query = new WP_query($agrs);
                            $field_ids = $query->posts;
                            
                            foreach ( $field_ids as $field_id ) {
                                $field_group = rwmb_meta('meta_box', array(), $field_id);
                                if ( !empty($field_group) ) {
                                    $fields = $field_group['fields'];
                                    foreach ($fields as $field) {
                                        if ( strpos( $field['id'], $_POST['search'] ) !== false ) {
                                            $return[] = array('metabox/' . $field['id'], 'METABOX > ' . $field_group['title'] . ' > ' . $field['name']);
                                        }
                                    }
                                }
                            }
                        }

                        if (function_exists('jet_engine')) {
                            $field_groups = get_option('jet_engine_meta_boxes');
                            if ( !empty($field_groups) ) {
                                foreach ( $field_groups as $field_group ) {
                                    $fields = $field_group['meta_fields'];
                                    foreach ( $fields as $field ) {
                                        if ( strpos( $field['name'], $_POST['search'] ) !== false ) {
                                            $return[] = array('jetengine/' . $field['name'], 'JetEngine > ' . $field_group['args']['name'] . ' > ' . $field['title']);
                                        }
                                    }
                                }
                            }
                        }
 					
						global $wpdb;

						$custom_fields = @$wpdb->get_results( 'SELECT DISTINCT meta_key FROM ' . $wpdb->prefix . 'postmeta WHERE meta_key LIKE "%' . $_POST['search'] . '%"', ARRAY_A );

 						foreach ($custom_fields as $custom_field) {
							$return[] = array( $custom_field['meta_key'], $custom_field['meta_key'] );
 						}

 						break;
 				}
 				
 				break;

 		}
		
		echo json_encode( $return );

		wp_die();
	}
