<?php

namespace Controls_piotnetgrid;

if ( ! defined( 'ABSPATH' ) ) { exit; }

abstract class piotnetgrid_Base_Control {
	abstract public function get_type();

	abstract public function get_control_template();

	public function get_template() {
		?>
		<script type="text/html" data-piotnetgrid-template id="piotnetgrid-<?php echo esc_attr( $this->get_type() ); ?>-control-template">
			<%
				let field_group_class = "piotnetgrid-control__field-group";
				if (data.separator) {
					field_group_class += " piotnetgrid-control__field-group--separator-" + data.separator;
				}

				const field_group_attributes = ["data-piotnetgrid-control"];
				if (data.responsive) {
					field_group_attributes.push('data-piotnetgrid-responsive="' + data.responsive + '"');
				}

				if (data.label_block) {
					field_group_attributes.push("data-piotnetgrid-control-label-block");
				}

				if ( data.conditions ) {
					field_group_attributes.push("data-piotnetgrid-control-conditions='" + JSON.stringify(data.conditions) + "'");
				}

				if ( data.dynamic_field ) {
					field_group_attributes.push("data-piotnetgrid-control-has-dynamic-field");
				}

				if ( !data.value && data.name.includes('__dynamic__') ) {
					field_group_attributes.push("style='display:none'");
				}

			%>
			<div class="<%= field_group_class %>"<% _.each(field_group_attributes, function(field_group_attribute) { %><%= " " + field_group_attribute %><% }); %>>
				<%= data.label ? '<label class="piotnetgrid-control__label">' + data.label + '</label>' : "" %>
				<div class='piotnetgrid-control__field'<%= data.field_width ? ' style="width:' + data.field_width + '!important"' : "" %>>
					<% if (data.responsive) { %>
					<div class="piotnetgrid-control__responsive">
						<span class="piotnetgrid-control__responsive-item active" data-piotnetgrid-control-responsive="desktop">Desktop</span>
						<span class="piotnetgrid-control__responsive-item" data-piotnetgrid-control-responsive="tablet">Tablet</span>
						<span class="piotnetgrid-control__responsive-item" data-piotnetgrid-control-responsive="mobile">Mobile</span>
					</div><% } %>
					<% if (data.dynamic) { %>
						<div class="piotnetgrid-control-dynamic-value" data-piotnetgrid-control-dynamic-value title="Dynamic Tags"><i class="fas fa-bolt"></i></div>
					<% } %>
					<% if (data.name.includes('__dynamic__')) { %>
						<div class="piotnetgrid-control-dynamic-value piotnetgrid-control-dynamic-value--remove" data-piotnetgrid-control-dynamic-value-remove title="Remove Dynamic Tags"><i class="fas fa-times"></i></div>
					<% } %>
					<?php $this->get_control_template(); ?>
				</div>
				<% if (data.description) { %>
				<div class="piotnetgrid-control__description"><%= data.description %></div>
				<% } %>
				<% if (data.description_has_value) { %>
				<div class="piotnetgrid-control__description piotnetgrid-control__description--has-value<% if (data.value) { %> active<% } %>" data-piotnetgrid-control-description-has-value>
					<div class="piotnetgrid-control__description--has-value-content" data-piotnetgrid-control-description-has-value-content><%= data.description_has_value.replace('{{VALUE}}', data.value) %></div>
					<div class="piotnetgrid-control__description--has-value-template" data-piotnetgrid-control-description-has-value-template><%= data.description_has_value %></div>
				</div>
				<% } %>
			</div>
		</script>
		<?php
	}
}

