<?php

namespace Controls_piotnetgrid;

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Control_Dimensions extends piotnetgrid_Base_Control {

	public function get_type() {
		return 'dimensions';
	}

	public function get_control_template() {
		?>
		<div class="piotnetgrid-control-dimensions" data-piotnetgrid-control-dimensions data-piotnetgrid-control-dimensions-name="<%= data.name %>" data-piotnetgrid-settings-not-field <%= data_type_html(data) %>>
			<div class="piotnetgrid-control-size-units">
				<% data['size_units'].forEach(function (size_unit) { %>
				<span class="<%= data['value']['unit'] == size_unit ? 'active' : '' %>" data-piotnetgrid-control-size-unit="<%= size_unit %>"><%= size_unit %></span>
				<% }) %>
			</div>
			<input type="hidden" data-piotnetgrid-control-unit data-piotnetgrid-control-dimensions="unit" value="<%= data['value']['unit'] %>">
			<% var input_type = data.dimension_text ? 'text' : 'number'; %>
			<ul class="piotnetgrid-control-dimensions-list">
				<li>
					<input type="<%= input_type %>" data-piotnetgrid-control-dimensions-group data-piotnetgrid-control-dimensions="top" data-piotnetgrid-settings-field value="<%= data['value']['top'] %>">
					<span class="piotnetgrid-control-dimensions__label">TOP</span>
				</li>
				<li>
					<input type="<%= input_type %>" data-piotnetgrid-control-dimensions-group data-piotnetgrid-control-dimensions="right" data-piotnetgrid-settings-field value="<%= data['value']['right'] %>">
					<span class="piotnetgrid-control-dimensions__label">RIGHT</span>
				</li>
				<li>
					<input type="<%= input_type %>" data-piotnetgrid-control-dimensions-group data-piotnetgrid-control-dimensions="bottom" data-piotnetgrid-settings-field value="<%= data['value']['bottom'] %>">
					<span class="piotnetgrid-control-dimensions__label">BOTTOM</span>
				</li>
				<li>
					<input type="<%= input_type %>" data-piotnetgrid-control-dimensions-group data-piotnetgrid-control-dimensions="left" data-piotnetgrid-settings-field value="<%= data['value']['left'] %>">
					<span class="piotnetgrid-control-dimensions__label">LEFT</span>
				</li>
				<% if(!data.dimension_text) { %>
				<li class="piotnetgrid-control-dimensions-islinked">
					<input type="checkbox" class="fas fa-link" data-piotnetgrid-control-dimensions="isLinked" value="1"<% if(data['value']['isLinked'] == '1' || data['value']['isLinked'] == undefined) { %>checked=""<% } %>>
				</li>
				<% } %>
			</ul>
		</div>
		<?php
	}
}
