<?php
	function piotnetgrid_facet_change_query($facets = [], $args_additional = [], $facet_exclude_id = '') {
		$tax_query = array();
		$meta_query = array();
		$post_not_in = array();

		if (!empty($facets)) {
			foreach ($facets as $facet) {
				$facet_value = !empty($facet['value']) ? $facet['value'] : '';
				if (empty($facet_exclude_id) || $facet_exclude_id != $facet['id']) {
					switch ($facet['action']) {
						case 'filter':
							switch ($facet['filter_type']) {
								case 'search':
									if (!empty($facet_value)) {
										$args_additional['query']['s'] = $facet_value;
									}
									break;
								case 'select':
								case 'radio':
								case 'checkboxes':
								case 'slider':
									if (!empty($facet_value)) {
										$filter_logic = !empty($facet['filter_logic']) ? $facet['filter_logic'] : 'IN';
										if (!is_array($facet_value) && $facet['filter_type'] == 'checkboxes') {
											$facet_value = explode(',', $facet_value);
										}
									}

									switch ($facet['filter_source']) {
										case 'taxonomy':
											if (!empty($facet_value)) {
												$tax_query[] = [
													'taxonomy' => $facet['filter_taxonomy'],
										            'field'    => 'slug',
										            'terms'    => $facet_value,
										            'operator' => $filter_logic,
												];

												if (headers_sent() || !empty($args_additional['piotnetgrid'])) {
													$post_not_in = piotnetgrid_get_product_variation_out_of_stock($facet['filter_taxonomy'], $facet_value);
												}
											}
											break;
										case 'custom_field':
											if ($facet_value != '' && $facet_value != []) {
												if ($facet['filter_type'] == 'slider') {
                                                    if (strpos($facet['filter_custom_field'], 'acf/') !== false && function_exists('acf_get_field_groups')) {
                                                        $acf_field_key = str_replace('acf/', '', $facet['filter_custom_field']);
                                                        $acf_field_object = get_field_object($acf_field_key);
                                                        $acf_field_name = $acf_field_object['name'];

                                                        $meta_query[] = [
                                                            'key' => $acf_field_name,
                                                            'value' => $facet['value'],
                                                            'type' => 'numeric',
                                                            'compare' => 'BETWEEN',
                                                        ];
                                                    } elseif (strpos($facet['filter_custom_field'], 'metabox/') !== false && function_exists('rwmb_meta')) {
                                                        $metabox_field_key = str_replace('metabox/', '', $facet['filter_custom_field']);
                                                        $meta_query[] = [
                                                            'key' => $metabox_field_key,
                                                            'value' => $facet['value'],
                                                            'type' => 'numeric',
                                                            'compare' => 'BETWEEN',
                                                        ];
                                                    } elseif ( strpos( $facet['filter_custom_field'], 'jetengine/' ) !== false && function_exists('jet_engine') ) {
                                                        $jetengine_field_key = str_replace('jetengine/', '', $facet['filter_custom_field']);
                                                        $meta_query[] = [
                                                            'key' => $jetengine_field_key,
                                                            'value' => $facet['value'],
                                                            'type' => 'numeric',
                                                            'compare' => 'BETWEEN',
                                                        ];
                                                    } else {
                                                        $meta_query[] = [
                                                            'key' => $facet['filter_custom_field'],
                                                            'value' => $facet['value'],
                                                            'type' => 'numeric',
                                                            'compare' => 'BETWEEN',
                                                        ];
                                                    }

												} else {
													$filter_custom_field_checkbox = false;

													if ( strpos( $facet['filter_custom_field'], 'acf/' ) !== false && function_exists('acf_get_field_groups') ) {
														$acf_field_key = str_replace('acf/', '', $facet['filter_custom_field']);
														$acf_field_object = get_field_object($acf_field_key);
														$acf_field_name = $acf_field_object['name'];
														$facet['filter_custom_field'] = $acf_field_name;

														if (in_array($acf_field_object['type'], ['checkbox','select','radio','button_group'])) {
															$filter_custom_field_checkbox = true;

															if ($acf_field_object['type'] == 'select' && $acf_field_object['multiple'] != 1 || $acf_field_object['type'] == 'radio') {
																$filter_custom_field_checkbox = false;
															}

															if ($filter_custom_field_checkbox) {
																$meta_query_item = [
																	'relation' => 'OR',
																];

																if (is_array($facet_value)) {
																	foreach ($facet_value as $facet_value_item) {
																		$meta_query_item[] = [
																			'key' => $acf_field_name,
																            'value' => '"' . $facet_value_item . '"',
																            'compare' => 'LIKE',
																		];
																	}
																} else {
																	$meta_query_item[] = [
																		'key' => $acf_field_name,
															            'value' => '"' . $facet_value . '"',
															            'compare' => 'LIKE',
																	];
																}

																$meta_query[] = $meta_query_item;
															}
														}
													}

                                                    if ( strpos( $facet['filter_custom_field'], 'metabox/' ) !== false && function_exists('rwmb_meta') ) {
                                                        $metabox_field_key = str_replace('metabox/', '', $facet['filter_custom_field']);
														$filter_custom_field_checkbox = true;

                                                        if (is_array($facet_value)) {
                                                        	$meta_query_item = [
	                                                            'relation' => 'OR',
	                                                        ];
                                                            foreach ($facet_value as $facet_value_item) {
                                                                $meta_query_item[] = [
                                                                    'key' => $metabox_field_key,
                                                                    'value' => $facet_value_item,
                                                                    'compare' => '=',
                                                                ];
                                                            }
                                                        } else {
                                                            $meta_query_item[] = [
                                                                'key' => $metabox_field_key,
                                                                'value' => $facet_value,
                                                                'compare' => '=',
                                                            ];
                                                        }

                                                        $meta_query[] = $meta_query_item;
                                                    }

                                                    if ( strpos(  $facet['filter_custom_field'], 'jetengine/' ) !== false && function_exists('jet_engine') ) {
                                                        $jetengine_field_key = str_replace('jetengine/', '', $facet['filter_custom_field']);
                                                        $jetengine_field_groups = get_option('jet_engine_meta_boxes');

                                                        foreach ( $jetengine_field_groups as $jetengine_field_group ) {
                                                            $jetengine_fields = $jetengine_field_group['meta_fields'];
                                                            foreach ( $jetengine_fields as $jetengine_field ) {
                                                                if ( ($jetengine_field['name'] == $jetengine_field_key) ) {
                                                                    $jetengine_field_name = $jetengine_field['name'];
                                                                    $facet['filter_custom_field'] = $jetengine_field_name;

                                                                    if (in_array($jetengine_field['type'], ['checkbox', 'select', 'radio', 'button_group'])) {
                                                                        $filter_custom_field_checkbox = true;

                                                                        if ($jetengine_field['type'] == 'select' && !$jetengine_field['is_multiple'] || $jetengine_field['type'] == 'radio') {
                                                                            $filter_custom_field_checkbox = false;
                                                                        }

                                                                        if (is_array($facet_value)) {
                                                                            $meta_query_item = [
                                                                                'relation' => 'OR',
                                                                            ];
                                                                            foreach ($facet_value as $facet_value_item) {
                                                                                $jetengine_field_value = $jetengine_field['type'] == 'select' || $jetengine_field['type'] == 'radio' ? $facet_value_item : '"' . $facet_value_item . '"' . ';s:4:"true';

                                                                                $jetengine_field_compare = $jetengine_field['type'] == 'select' && !$jetengine_field['is_multiple'] || $jetengine_field['type'] == 'radio' ? '=' : 'LIKE';

                                                                                $meta_query_item[] = [
                                                                                    'key' => $jetengine_field_name,
                                                                                    'value' => $jetengine_field_value,
                                                                                    'compare' => $jetengine_field_compare,
                                                                                ];
                                                                            }
                                                                        } else {
                                                                            $jetengine_field_value = $jetengine_field['type'] == 'select' || $jetengine_field['type'] == 'radio' ? $facet_value : '"' . $facet_value . '"' . ';s:4:"true';

                                                                            $jetengine_field_compare = $jetengine_field['type'] == 'select' && !$jetengine_field['is_multiple'] || $jetengine_field['type'] == 'radio' ? '=' : 'LIKE';

                                                                            $meta_query_item[] = [
                                                                                'key' => $jetengine_field_name,
                                                                                'value' => $jetengine_field_value,
                                                                                'compare' => $jetengine_field_compare,
                                                                            ];
                                                                        }

                                                                        $meta_query[] = $meta_query_item;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }

													if (!$filter_custom_field_checkbox) {
														$meta_query[] = [
															'key' => $facet['filter_custom_field'],
												            'value' => $facet_value,
														];
													}
												}
											}
											break;
										case 'author':
											if (!empty($facet_value)) {
												if (is_array($facet_value)) {
													$facet_value = array_map(function($value) {
													    return intval($value);
													}, $facet_value);

													$args_additional['query']['author__in'] = $facet_value;
												} else {
													$args_additional['query']['author'] = $facet_value;
												}
											}
											break;
									}
									break;

								case 'date':
									if (!empty($facet_value)) {
										$facet_date_query = [];
										$facet_dates = explode(' to ', $facet_value);
										$facet_dates = array_map(function ($a) { return date('Y-m-d',strtotime($a)); }, $facet_dates);

										switch ($facet['filter_source']) {
											case 'custom_field':
												if (count($facet_dates) == 1) {
													$meta_query[] = [
														'key' => $facet['filter_custom_field'],
											            'value' => $facet_dates[0],
											            'type' => 'DATE',
													];
												} else {
													$meta_query[] = [
														'key' => $facet['filter_custom_field'],
											            'value' => $facet_dates,
											            'type' => 'DATE',
											            'compare' => 'BETWEEN',
													];
												}
												break;

											case 'post_date':
												if (count($facet_dates) == 1) {
													$facet_date_query = array(
												        'year'  => date('Y',strtotime($facet_dates[0])),
												        'month' => date('m',strtotime($facet_dates[0])),
												        'day'   => date('d',strtotime($facet_dates[0])),
												    );
												} else {
													$facet_date_query = array(
												        array(
												            'after'     => $facet_dates[0],
												            'before'    => $facet_dates[1],
												            'inclusive' => true,
												        )
												    );
												}
												$args_additional['query']['date_query'] = $facet_date_query;
												break;
										}
									}
									break;

                                case 'az':
                                    $args_additional['query']['piotnetgrid_query_starts_with'] = $facet_value;
                                    break;
							}

							break;

						case 'sort':
							if (!empty($facet_value)) {
								$facet_order = substr($facet_value, -4) == 'desc' ? 'DESC' : 'ASC';
								if (substr($facet_value, 0, 4) == 'meta') {
									if (substr($facet_value, 0, 10) == 'meta_value') {
										$facet_order_by = 'meta_value';
										$facet_order_meta_key = substr($facet_value, 11, strlen($facet_value) - strlen($facet_order) - 12);
									} else {
										$facet_order_by = 'meta_value_num';
										$facet_order_meta_key = substr($facet_value, 9, strlen($facet_value) - strlen($facet_order) - 10);

									}
									$args_additional['query']['orderby'] = $facet_order_by;
									$args_additional['query']['order'] = $facet_order;
									$args_additional['query']['meta_key'] = $facet_order_meta_key;
								} else {
									$facet_order_by = substr($facet_value, 0, strlen($facet_value) - strlen($facet_order) - 1);
									$args_additional['query']['orderby'] = $facet_order_by;
									$args_additional['query']['order'] = $facet_order;
								}
							}
							break;

						case 'load':

							switch ($facet['loading_type']) {
								case 'pagination':
								case 'load_more':

									if (!empty($facet_value)) {
										$args_additional['query']['paged'] = $facet_value;
									}
									break;
									
								case 'posts_per_page':
									if (!empty($facet_value)) {
										$args_additional['query']['posts_per_page'] = $facet_value;
									}
									break;
							}

							break;
					}
				}
			}
		}

		if (!empty($tax_query)) {
			$args_additional['query']['tax_query'] = $tax_query;
		}

		if (!empty($meta_query)) {
			$args_additional['query']['meta_query'] = $meta_query;
		}

		if (!empty($post_not_in)) {
			$args_additional['query']['post__not_in'] = array_unique($post_not_in);
		}

		// print_r($args_additional);
		// die();

		return $args_additional;
	}

	function piotnetgrid_get_facet_by_name($facet_name = '', $facet_value = '', $facet_post_ids = []) {
		$facet_data = get_option('_piotnetgrid_facet' . $facet_name);
		if (!empty($facet_data)) {
			$facet_settings = json_decode( stripslashes( $facet_data ), true );

			if (!empty($facet_post_ids) && !in_array($facet_settings['post_id'], $facet_post_ids)) {
				return '';
			}

			$facet = [
				'name' => $facet_name,
				'value' => $facet_value,
				'action' => $facet_settings['facet_action'],
			];

			switch ($facet_settings['facet_action']) {
				case 'filter':
					if (in_array($facet_settings['filter_type'], ['checkboxes','buttons','color-picker','image-select'])) {
						$facet_settings['filter_type'] = 'checkboxes';
					}

					$facet['filter_type'] = !empty($facet_settings['filter_type']) ? $facet_settings['filter_type'] : '';
					$facet['filter_source'] = !empty($facet_settings['filter_data_source']) ? $facet_settings['filter_data_source'] : '';
					$facet['filter_taxonomy'] = !empty($facet_settings['filter_data_source_taxonomy']) ? $facet_settings['filter_data_source_taxonomy'] : '';
					$facet['filter_custom_field'] = !empty($facet_settings['filter_data_source_custom_field']) ? $facet_settings['filter_data_source_custom_field'] : '';
					$facet['filter_logic'] = !empty($facet_settings['filter_logic']) ? $facet_settings['filter_logic'] : '';
					break;
				
				case 'load':
					$facet['loading_type'] = !empty($facet_settings['loading_type']) ? $facet_settings['loading_type'] : '';
					break;
			}

			return $facet;
		}
	}

	function piotnetgrid_get_facet_post_ids($facet_name = '', $facet_value = '', $facet_post_ids = []) {
		$facet = piotnetgrid_get_facet_by_name($facet_name, $facet_value, $facet_post_ids);

		if (empty($facet)) {
			return [];
		}

		$facet_query = piotnetgrid_facet_change_query([$facet]);

		$facet_query['query']['post_type'] = 'any';
		$facet_query['query']['fields'] = 'ids';
		$facet_query['query']['posts_per_page'] = 1000000000;
		//print_r($facet_query['query']);
		$facet_posts_query = new WP_Query($facet_query['query']);

		//var_dump($facet_posts_query->posts);

		return $facet_posts_query->posts;
	}

	function piotnetgrid_get_facet_settings_by_name($facet_name = '', $facet_value = '') {
		$facet_settings = json_decode( stripslashes( get_option('_piotnetgrid_facet' . $facet_name) ), true );

		return $facet_settings;
	}

	function piotnetgrid_get_facets() {
		$facets = [];
		foreach ($_GET as $facet_name => $facet_value) {
			$facet_settings = get_option('_piotnetgrid_facet' . $facet_name);
			if (!empty($facet_settings)) {
				$facets[] = piotnetgrid_get_facet_by_name($facet_name, $facet_value);
			}
		}
		return $facets;
	}

	function piotnetgrid_get_cache($request_url, $grid_post_id) {
		global $wpdb;
		$current_time = strtotime('now');
		$cache_name = md5($request_url . $grid_post_id);
		$table_name = $wpdb->prefix . 'piotnetgrid_cache';
		$cache_file = '';
		$cache = $wpdb->get_results( 'SELECT file FROM ' . $table_name . '  WHERE name = "' . $cache_name . '" AND (expiration>' . $current_time . ' OR expiration=0)', ARRAY_A );
		if (!empty($cache)) {
			$cache_file = $cache[0]['file'] . '.json';
		}
		return $cache_file;
	}

	function piotnetgrid_set_cache($request_url, $url_path, $expiration_plus, $grid_post_id) {
		global $wpdb;
		$expiration = !empty($expiration_plus) ? strtotime('+' . $expiration_plus . ' seconds') : 0;
		$cache_name = md5($request_url . $grid_post_id);
		$table_name = $wpdb->prefix . 'piotnetgrid_cache';

		$wpdb->insert( 
			$table_name, 
			array( 
				'name' => $cache_name,
				'file' => $cache_name,
				'url_path' => $url_path,
				'expiration' => $expiration,
			) 
		);

		$id = $wpdb->insert_id;

		$wpdb->update( $table_name, ['file' => $cache_name . '_' . base64_encode($id)], ['id' => $id] );

		return $id;
	}

	function piotnetgrid_get_product_variation_out_of_stock($taxonomy, $term) {
		$post_not_in = [];

		if (class_exists( 'WooCommerce' ) && substr($taxonomy, 0, 3) == 'pa_' && get_option('woocommerce_hide_out_of_stock_items') == 'yes') {
            $product_variation_out_of_stock_query = new WP_Query(
            	[
            		'post_type' => 'product_variation',
            		'posts_per_page' => -1,
            		'fields' => 'id=>parent',
            		'meta_query' => [
            			'relation' => 'AND',
            			[
            				'key' => '_stock_status',
							'value' => 'outofstock',
            			],
            			[
            				'key' => 'attribute_' . $taxonomy,
							'value' => $term,
            			],
            		]
            	]
            );

            if (!empty($product_variation_out_of_stock_query->posts)) {
            	foreach ($product_variation_out_of_stock_query->posts as $post) {
            		$post_not_in[] = $post->post_parent;
            	}
            }
        }

        return $post_not_in;
	}