<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

function piotnetgrid_editor_meta_box() {
	add_meta_box( 'piotnetgrid-editor-meta-box', 'Piotnet Grid', 'piotnetgrid_editor_meta_box_output', 'piotnetgrid' );
}
	add_action( 'add_meta_boxes', 'piotnetgrid_editor_meta_box', 10 );

function piotnetgrid_editor_meta_box_output( $post ) {
	require_once __DIR__ . '/../class/piotnetgrid-editor.php';
	require_once __DIR__ . '/../widgets/section.php';
	require_once __DIR__ . '/../widgets/spacer.php';

	$post_meta_data = get_post_meta( $post->ID, '_piotnetgrid_data', true );
	$data           = json_decode( $post_meta_data, true );
	$widget_content = $data['content'];

	$editor = new piotnetgrid_Editor();

	$widget_object = new piotnetgrid_Section();

	$editor->register_widget( $widget_object );

	$widget_object = new piotnetgrid_Text();

	$editor->register_widget( $widget_object );

	$widget_object = new piotnetgrid_Button();

	$editor->register_widget( $widget_object );

	$widget_object = new piotnetgrid_Image();

	$editor->register_widget( $widget_object );

    $widget_object = new piotnetgrid_Gallery();

	$editor->register_widget( $widget_object );

	$widget_object = new piotnetgrid_Icon();

	$editor->register_widget( $widget_object );

    $widget_object = new piotnetgrid_Video();

	$editor->register_widget( $widget_object );

	$widget_object = new piotnetgrid_Spacer();

	$editor->register_widget( $widget_object );

	echo '<div class="piotnetgrid-editor">';

	echo '<div class="piotnetgrid-settings">';
		$editor->editor_panel();
	echo '</div>';

	echo '<div class="piotnetgrid-widget-preview piotnetgrid" id="piotnetgrid" data-piotnetgrid-widget-preview data-piotnetgrid-sortable>';
	$editor->editor_preview( $widget_content );
	echo '</div>';

	echo '<div class="piotnetgrid-editor__bottom">';
	echo '<div class="piotnetgrid-editor__save" data-piotnetgrid-editor-save><i class="far fa-save"></i> Save</div>';
	echo '</div>';

	echo '</div>';

	// echo '<br>';

	echo "<div><input type='hidden' name='piotnetgrid-widget-post-id' value='{$post->ID}' data-piotnetgrid-widget-post-id></div>";
	echo "<div><input type='hidden' name='piotnetgrid-widget-breakpoint-tablet' value='1025px' data-piotnetgrid-widget-breakpoint-tablet></div>";
	echo "<div><input type='hidden' name='piotnetgrid-widget-breakpoint-mobile' value='768px' data-piotnetgrid-widget-breakpoint-mobile></div>";

	echo "<div><textarea style='display:none' name='piotnetgrid-data' data-piotnetgrid-data>{$post_meta_data}</textarea></div>";

	// Collape Menu
	// echo "<script>jQuery(document).ready(function( $ ) { $('body').addClass('folded'); })</script>";

	echo '<div data-piotnetgrid-ajax-url="' . admin_url( 'admin-ajax.php' ) . '"></div>';
	echo '<div data-piotnetgrid-tinymce-upload="' . plugins_url() . '/piotnetgrid-pro/inc/tinymce/tinymce-upload.php"></div>';
	echo '<div data-piotnetgrid-stripe-key="' . esc_attr( get_option( 'piotnetgrid-stripe-publishable-key' ) ) . '"></div>';
	echo '<script src="https://maps.googleapis.com/maps/api/js?key=' . esc_attr( get_option( 'piotnetgrid-google-maps-api-key' ) ) . '&libraries=places&callback=piotnetgridAddressAutocompleteInitMap" async defer></script>';

	?>
		<style>
			#post-body {
				display: flex;
				flex-wrap: wrap;
				margin-right: 0 !important;
			}

			#postbox-container-1 {
				float:right !important;
				margin-right: 0 !important;
				order: 3;
				width: 100% !important;
			}

			#side-sortables {
				width: 100% !important;
			}
		</style>
	<?php
}

function piotnetgrid_editor_meta_box_save( $post_id ) {
	if ( isset( $_POST['piotnetgrid_data'] ) ) {
		$raw_data = stripslashes( $_POST['piotnetgrid_data'] );

		$data            = json_decode( $raw_data, true );
		$data['version'] = DATA_VERSION_PIOTNETGRID;
		$data_str        = json_encode( $data );
		update_post_meta( $post_id, '_piotnetgrid_data', wp_slash( $data_str ) );
	}

	if ( isset( $_POST['piotnetgrid-widgets-css'] ) ) {
		$widgets_css      = $_POST['piotnetgrid-widgets-css'];
		$revision_version = intval( get_post_meta( $post_id, '_piotnetgrid-revision-version', true ) ) + 1;
		update_post_meta( $post_id, '_piotnetgrid-revision-version', $revision_version );

		$upload     = wp_upload_dir();
		$upload_dir = $upload['basedir'];
		$upload_dir = $upload_dir . '/piotnetgrid/css/';

		$file = fopen( $upload_dir . $post_id . '.css', 'wb' );
		fwrite( $file, stripslashes( $widgets_css ) );
		fclose( $file );
	}

}
	add_action( 'save_post', 'piotnetgrid_editor_meta_box_save' );

	add_action( 'admin_head', 'piotnetgrid_css' );

function piotnetgrid_css() {
    // TODO load css from file
	echo '<style data-piotnetgrid-widget-css-head>' . get_post_meta( get_the_ID(), '_piotnetgrid-widgets-css', true ) . '</style>';

	$post_id = get_the_ID();

	if ( $post_id != false ) {
		$widget_settings = get_post_meta( $post_id, '_piotnetgrid-settings', true );

		if ( ! empty( $widget_settings ) ) {
			$widget_settings = json_decode( $widget_settings, true );
			if ( ! empty( $widget_settings['fonts'] ) ) {
				$fonts = $widget_settings['fonts'];
				foreach ( $fonts as $font ) {
					echo '<link href="' . $font . '" rel="stylesheet">';
				}
			}
		}
	}
}
