<?php
class Piotnetgrid_Analytics{

    public static function piotnetgrid_analytic_get_percentage_value(int $number, string $format){
        global $wpdb;
        $percentage = [];
        $total_click = 0;
        $query = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE grouped=0 and no_results=0  and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(CURDATE(), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        $query_two = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE grouped=0 and no_results=0 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.($number*2).' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        if($query){
            foreach($query as $key => $value){
                $total_click += intval($value['count']);
                $facet_value = $value['facet_value'];
                $facet_label = !empty($value['facet_label']) ? $value['facet_label'] : $value['facet_name'];
                if($query_two){
                    foreach($query_two as $index => $item){
                        if($item['facet_value'] == $facet_value && $item['facet_name'] == $value['facet_name']){
                            $percentage[$key] = [
                                'name' => $facet_label.': '.$value['facet_value'],
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => round(intval($item['count']) / intval($number), 2),
                                'total_click' => $value['count'],
                            ];
                            break;
                        }
                        else{
                            $percentage[$key] = [
                                'name' => $facet_label.': '.$value['facet_value'],
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => 0,
                                'total_click' => $value['count'],
                            ];
                        }
                    }
                }else{
                    $percentage[$key] = [
                        'name' => $facet_label.': '.$value['facet_value'],
                        'current_month' => round(intval($value['count']) / intval($number), 2),
                        'last_month' => 0,
                        'total_click' => $value['count'],
                    ];
                }
            }
        }
        $total_percentage = 0;
        foreach($percentage as $key => $val){
            $increase = $val['current_month'] - $val['last_month'];
            if($val['last_month'] == 0){
                $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>100%';
            }else{
                if($increase > 0){
                    $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>'.round(($increase/$val['last_month'])*100, 2).'%';
                }else{
                    $percentage[$key]['increase'] =  '<span style="color:red;">&#8595; </span>'.round((abs($increase)/$val['last_month'])*100, 2).'%';
                }
            }
            if($key != count($percentage)-1){
                $percentage[$key]['percent'] = round(intval($val['total_click']) / intval($total_click) * 100, 2);
                $total_percentage += round(intval($val['total_click']) / intval($total_click) * 100, 2);
            }else{
                $percentage[$key]['percent'] = round((100 - $total_percentage), 2);
            }
            
        }
        return $percentage;
    }
    public static function piotnetgrid_analytic_get_percentage_combination(int $number, string $format){
        global $wpdb;
        $percentage = [];
        $total_click = 0;
        $query = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE grouped=1 and no_results=0 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(CURDATE(), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        $query_two = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE grouped=1 and no_results=0 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.($number*2).' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        if($query){
            foreach($query as $key => $value){
                $total_click += intval($value['count']);
                $facet_value = $value['facet_value'];
                if($query_two){
                    foreach($query_two as $index => $item){
                        if($item['facet_value'] == $facet_value && $item['facet_name'] == $value['facet_name']){
                            $facet_value = json_decode($value['facet_value']);
                            $facet_label = json_decode($value['facet_label']);
                            $facet_name = json_decode($value['facet_name']);
                            $name = '';
                            foreach($facet_label as $i => $label){
                                $l = !empty($label) ? $label : $facet_name[$i];
                                $name .= $l. ": " . $facet_value[$i].'<br>';
                            }
                            $percentage[$key] = [
                                'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => round(intval($item['count']) / intval($number), 2),
                                'total_click' => $value['count'],
                            ];
                            break;
                        }else{
                            $facet_value = json_decode($value['facet_value']);
                            $facet_label = json_decode($value['facet_label']);
                            $facet_name = json_decode($value['facet_name']);
                            $name = '';
                            foreach($facet_label as $i => $label){
                                $l = !empty($label) ? $label : $facet_name[$i];
                                $name .= $l. ": " . $facet_value[$i].'<br>';
                            }
                            $percentage[$key] = [
                                'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => 0,
                                'total_click' => $value['count'],
                            ];
                        }
                    }
                }else{
                    $facet_value = json_decode($value['facet_value']);
                    $facet_label = json_decode($value['facet_label']);
                    $facet_name = json_decode($value['facet_name']);
                    $name = '';
                    foreach($facet_label as $i => $label){
                        $l = !empty($label) ? $label : $facet_name[$i];
                        $name .= $l. ": " . $facet_value[$i].'<br>';
                    }
                    $percentage[$key] = [
                        'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                        'current_month' => round(intval($value['count']) / intval($number), 2),
                        'last_month' => 0,
                        'total_click' => $value['count'],
                    ];
                }
                
            }
        }
        $total_percentage = 0;
        foreach($percentage as $key => $val){
            $increase = $val['current_month'] - $val['last_month'];
            if($val['last_month'] == 0){
                $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>100%';
            }else{
                if($increase > 0){
                    $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>'.round(($increase/$val['last_month'])*100, 2).'%';
                }else{
                    $percentage[$key]['increase'] =  '<span style="color:red;">&#8595; </span>'.round((abs($increase)/$val['last_month'])*100, 2).'%';
                }
            }
            if($key != count($percentage)-1){
                $percentage[$key]['percent'] = round(intval($val['total_click']) / intval($total_click) * 100, 2);
                $total_percentage += round(intval($val['total_click']) / intval($total_click) * 100, 2);
            }else{
                $percentage[$key]['percent'] = round((100 - $total_percentage), 2);
            }
        }
        return $percentage;
    }
    public static function piotnetgrid_analytic_get_percentage_terms_grouped(int $number, string $format){
        global $wpdb;
        $percentage = [];
        $total_click = 0;
        $query = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE no_results=1 and grouped=1 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(CURDATE(), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        $query_two = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE no_results=1 and grouped=1 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.($number*2).' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        if($query){
            foreach($query as $key => $value){
                $total_click += intval($value['count']);
                $facet_value = $value['facet_value'];
                if($query_two){
                    foreach($query_two as $index => $item){
                        if($item['facet_value'] == $facet_value && $item['facet_name'] == $value['facet_name']){
                            $facet_value = json_decode($value['facet_value']);
                            $facet_label = json_decode($value['facet_label']);
                            $facet_name = json_decode($value['facet_name']);
                            $name = '';
                            foreach($facet_label as $i => $label){
                                $l = !empty($label) ? $label : $facet_name[$i];
                                $name .= $l. ": " . $facet_value[$i].'<br>';
                            }
                            $percentage[$key] = [
                                'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => round(intval($item['count']) / intval($number), 2),
                                'total_click' => $value['count'],
                            ];
                            break;
                        }else{
                            $facet_value = json_decode($value['facet_value']);
                            $facet_label = json_decode($value['facet_label']);
                            $facet_name = json_decode($value['facet_name']);
                            $name = '';
                            foreach($facet_label as $i => $label){
                                $l = !empty($label) ? $label : $facet_name[$i];
                                $name .= $l. ": " . $facet_value[$i].'<br>';
                            }
                            $percentage[$key] = [
                                'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => 0,
                                'total_click' => $value['count'],
                            ];
                        }
                    }
                }else{
                    $facet_value = json_decode($value['facet_value']);
                    $facet_label = json_decode($value['facet_label']);
                    $facet_name = json_decode($value['facet_name']);
                    $name = '';
                    foreach($facet_label as $i => $label){
                        $l = !empty($label) ? $label : $facet_name[$i];
                        $name .= $l. ": " . $facet_value[$i].'<br>';
                    }
                    $percentage[$key] = [
                        'name' => '<span class="piotnetgrid-analytic-name">'.rtrim($name, '<br>').'<span>',
                        'current_month' => round(intval($value['count']) / intval($number), 2),
                        'last_month' => 0,
                        'total_click' => $value['count'],
                    ];
                }
                
            }
        }
        $percentage['total_click'] = $total_click;
        return $percentage;
    }
    public static function piotnetgrid_analytic_get_percentage_terms_not_grouped(int $number, string $format){
        global $wpdb;
        $percentage = [];
        $total_click = 0;
        $query = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE no_results=1 and grouped=0 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(CURDATE(), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        $query_two = $wpdb->get_results('SELECT facet_name, facet_value, facet_label, grouped, count(*) AS "count" FROM ' . $wpdb->prefix . 'piotnetgrid_analytics WHERE no_results=1 and grouped=0 and DATE_FORMAT(time, "%Y-%c-%d") > DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.($number*2).' '.strtoupper($format).'), "%Y-%c-%d") and DATE_FORMAT(time, "%Y-%c-%d") <= DATE_FORMAT(DATE_ADD(CURDATE(), INTERVAL -'.$number.' '.strtoupper($format).'), "%Y-%c-%d") GROUP BY facet_name, facet_value', ARRAY_A);
        if($query){
            foreach($query as $key => $value){
                $total_click += intval($value['count']);
                $facet_value = $value['facet_value'];
                $label = !empty($value['facet_label']) ? $value['facet_label'] : $value['facet_name'];
                if($query_two){
                    foreach($query_two as $index => $item){
                        if($item['facet_value'] == $facet_value && $item['facet_name'] == $value['facet_name']){
                            $percentage[$key] = [
                                'name' => $label.': '.$value['facet_value'],
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => round(intval($item['count']) / intval($number), 2),
                                'total_click' => $value['count'],
                            ];
                            break;
                        }
                        else{

                            $percentage[$key] = [
                                'name' => $label.': '.$value['facet_value'],
                                'current_month' => round(intval($value['count']) / intval($number), 2),
                                'last_month' => 0,
                                'total_click' => $value['count'],
                            ];
                        }
                    }
                }else{

                    $percentage[$key] = [
                        'name' => $label.': '.$value['facet_value'],
                        'current_month' => round(intval($value['count']) / intval($number), 2),
                        'last_month' => 0,
                        'total_click' => $value['count'],
                    ];
                }
            }
        }
        $percentage_grouped = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_terms_grouped($number, $format);
        $total_click = $total_click + $percentage_grouped['total_click'];
        unset($percentage_grouped['total_click']);
        $percentage = array_merge($percentage_grouped, $percentage);

        $total_percentage = 0;
        foreach($percentage as $key => $val){
            $increase = $val['current_month'] - $val['last_month'];
            if($val['last_month'] == 0){
                $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>100%';
            }else{
                if($increase > 0){
                    $percentage[$key]['increase'] =  '<span style="color:#4ab635;">&#8593; </span>'.round(($increase/$val['last_month'])*100, 2).'%';
                }else{
                    $percentage[$key]['increase'] =  '<span style="color:red;">&#8595; </span>'.round((abs($increase)/$val['last_month'])*100, 2).'%';
                }
            }
            if($key != count($percentage)-1){
                $percentage[$key]['percent'] = round(intval($val['total_click']) / intval($total_click) * 100, 2);
                $total_percentage += round(intval($val['total_click']) / intval($total_click) * 100, 2);
            }else{
                $percentage[$key]['percent'] = round((100 - $total_percentage), 2);
            }
            
        }
        return $percentage;
    }

}
$number = isset($_REQUEST['number']) ? $_REQUEST['number'] : 1;
if(isset($_REQUEST['format']) && $_REQUEST['format'] == 'year' && $number == 1){
    $number = 365;
}else if(isset($_REQUEST['format']) && $_REQUEST['format'] == 'month' && $number == 1){
    $number = 30;
}
if(isset($_REQUEST['number']) && isset($_REQUEST['format'])){
    $analytics = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_value($_REQUEST['number'], $_REQUEST['format']);
    $analytics_combinations = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_combination($_REQUEST['number'], $_REQUEST['format']);
    $analytics_no_results = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_terms_not_grouped($_REQUEST['number'], $_REQUEST['format']);
}else{
    $analytics = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_value(1, 'day');
    $analytics_combinations = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_combination(1, 'day');
    $analytics_no_results = Piotnetgrid_Analytics::piotnetgrid_analytic_get_percentage_terms_not_grouped(1, 'day');
}
?>
<div class="piotnetgrid-analytics wrap">
    <div class="piotnetgrid-analytics-body">
        <div class="piotnetgrid-analytics-values">
            <h1 class="piotnetgrid-analytics-heading">Analytics</h1>
            <div class="piotnetgrid-analytics-group">
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 1 ? ' piotnetgrid-active' : ''; ?>">1 Day</a>
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid&number=7&format=day' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 7 ? ' piotnetgrid-active' : ''; ?>">7 Days</a>
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid&number=14&format=day' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 14 ? ' piotnetgrid-active' : ''; ?>">14 Days</a>
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid&number=1&format=month' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 30 ? ' piotnetgrid-active' : ''; ?>">1 Month</a>
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid&number=3&format=month' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 3 ? ' piotnetgrid-active' : ''; ?>">3 Months</a>
                <a href="<?php echo esc_url( get_admin_url( null, 'admin.php?page=analytic-piotnetgrid&number=1&format=year' ) ); ?>" type="button" class="btn piotnetgrid-analytic-button-group<?php echo $number == 365 ? ' piotnetgrid-active' : ''; ?>">1 Year</a>
            </div>
                <div class="piotnetgrid-analytics-title"><h4>Top filter option values</h4></div>
                <table class="piotnetgrid-analytics uk-table uk-table-hover uk-table-striped">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Filter options</th>
                            <th>Percentage change</th>
                            <th>Total Percentage</th>
                            <th>Total clicks</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php foreach($analytics as $index => $item): ?>
                        <tr>
                            <td><?php echo $index+1; ?></td>
                            <td><?php echo $item['name']; ?></td>
                            <td><?php echo $item['increase']; ?></td>
                            <td><?php echo $item['percent']; ?>%</td>
                            <td><?php echo $item['total_click']; ?></td>
                        </tr>
                        <?php endforeach; ?>
                    </tbody>
                </table>
            </div>
        <hr>
        <div class="piotnetgrid-analytics-combinations">
            <div class="piotnetgrid-analytics-title"><h4>Top filter option value combinations</h4></div>
            <table class="piotnetgrid-analytics uk-table uk-table-hover uk-table-striped">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Filter options</th>
                        <th>Percentage change</th>
                        <th>Total Percentage</th>
                        <th>Total clicks</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach($analytics_combinations as $index => $item): ?>
                    <tr>
                        <td><?php echo $index+1; ?></td>
                        <td><?php echo $item['name']; ?></td>
                        <td><?php echo $item['increase']; ?></td>
                        <td><?php echo $item['percent']; ?>%</td>
                        <td><?php echo $item['total_click']; ?></td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>
        <hr>
        <div class="piotnetgrid-analytics-combinations">
            <div class="piotnetgrid-analytics-title"><h4>Top search terms with no result</h4></div>
            <table class="piotnetgrid-analytics uk-table uk-table-hover uk-table-striped">
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Filter options</th>
                        <th>Percentage change</th>
                        <th>Total Percentage</th>
                        <th>Total clicks</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach($analytics_no_results as $index => $item):?>
                    <tr>
                        <td><?php echo $index+1; ?></td>
                        <td><?php echo $item['name']; ?></td>
                        <td><?php echo $item['increase']; ?></td>
                        <td><?php echo $item['percent']; ?>%</td>
                        <td><?php echo $item['total_click']; ?></td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>
    </div>
</div>