<?php
if ( ! defined( 'ABSPATH' ) ) { exit; }

if ( ! empty( $_GET['action'] ) && $_GET['action'] == 'active_license' && ! empty( $_GET['siteKey'] ) && ! empty( $_GET['licenseKey'] ) ) {
    if (isset($_GET['nonce']) && wp_verify_nonce( $_GET['nonce'], "active_nonce" )) {
        Piotnetgrid_License_Service::set_key( $_GET['siteKey'], $_GET['licenseKey'] );
        $share_data = isset($_GET['shareData']) && $_GET['shareData'] == 'yes';
        Piotnetgrid_License_Service::set_share_data($share_data ? 'yes' : 'no');
        Piotnetgrid_License_Service::clean_get_info_cache();
    }
    echo '<meta http-equiv="refresh" content="0; url=' . get_admin_url(null,'admin.php?page=piotnetgrid') . '" />';
    return;
}

$has_key = Piotnetgrid_License_Service::has_key();
$message = '';

if (isset($_POST['action']) && $_POST['action'] == 'remove_license'){
    if ($has_key) {
        $res = Piotnetgrid_License_Service::remove_license();
        if (isset($res['data']) && isset($res['data']['status']) && $res['data']['status'] == "S") {
            $message = "Deactivate license successfully.";
        }
    }
    Piotnetgrid_License_Service::clear_license_data();
    Piotnetgrid_License_Service::clear_key();
    $has_key = false;
}

$license_data = Piotnetgrid_License_Service::get_license_data(true);

if (isset($license_data) && isset($license_data['error'])) {
    $license_error = $license_data['error'];
    $res_msg = isset($license_error['message']) ? $license_error['message'] : 'Unknown message';
    $res_code = isset($license_error['code']) ? $license_error['code'] : '9999';
    $message = "$res_msg [$res_code]";
}

$license_data = Piotnetgrid_License_Service::get_license_data();
$has_valid_license = Piotnetgrid_License_Service::has_valid_license();

	if ( isset($_GET['post']) ) {

		echo '<div class="piotnetgrid-builder">';
		echo '<div data-piotnetgrid-ajax-url="' . admin_url( 'admin-ajax.php' ) . '"></div>';
		echo '<div data-piotnetgrid-tinymce-upload="' . plugins_url() . '/piotnetgrid-pro/inc/tinymce/tinymce-upload.php"></div>';

		if ( current_user_can( 'edit_others_posts' ) ) {

			$post_id = $_GET['post'];
			$piotnetgrid_data = get_post_meta( $post_id, '_piotnetgrid_data', true );
			$post_type = get_post_type($post_id);

			$raw_single_settings = get_post_meta( $post_id, '_piotnetgrid_single_settings', true );

	        if (!empty($raw_single_settings)) {
	        	$single_settings = json_decode( $raw_single_settings, true );
				$preview_card_post_id = !empty($single_settings['single-settings']['fields']['preview_post']) ? $single_settings['single-settings']['fields']['preview_post'] : '';
				if (!empty($preview_card_post_id)) {
					echo '<div data-piotnetgrid-preview-card-post-id="' . $preview_card_post_id . '"></div>';
				}
	        }

			$widget_infos = [];
			$global_settings = [];
			$single_settings = [];

			$editor = new piotnetgrid_Editor();
			$widget_object                              = new piotnetgrid_Section();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );

			$widget_object                              = new piotnetgrid_Column();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();

			$widget_object                              = new piotnetgrid_Text();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			if (empty($preview_card_post_id)) {
				echo $editor->register_script( $widget_object );
			}

			if (in_array($post_type, ['piotnetgrid'])) {
				$widget_object                              = new piotnetgrid_Grid();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
			}

			if (in_array($post_type, ['piotnetgrid-facet'])) {
				$widget_object                              = new piotnetgrid_Facet();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
			}

			if (in_array($post_type, ['piotnetgrid-facet'])) {
				$widget_object                              = new Piotnetgrid_Facet_Reset();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );

				$widget_object                              = new Piotnetgrid_Facet_Active();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );

				$widget_object                              = new Piotnetgrid_Facet_Apply();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
			}

			if (in_array($post_type, ['piotnetgrid-template', 'piotnetgrid-archive'])) {
				$widget_object                              = new Piotnetgrid_Facet_Embed();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );

				$widget_object                              = new Piotnetgrid_Grid_Embed();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );

				$widget_object                              = new Piotnetgrid_Template();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
			}

			$widget_object                              = new piotnetgrid_Button();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			// echo $editor->register_script( $widget_object );

			if (in_array($post_type, ['piotnetgrid-card'])) {
	            $widget_object                              = new piotnetgrid_Term_List();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );
	            if (empty($preview_card_post_id)) {
	            	echo $editor->register_script( $widget_object );
            	}
            }

			$widget_object                              = new piotnetgrid_Image();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			//echo $editor->register_script( $widget_object );

			if (in_array($post_type, ['piotnetgrid-card'])) {
	            $widget_object                              = new piotnetgrid_Gallery();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
				//echo $editor->register_script( $widget_object );

				$widget_object                              = new piotnetgrid_Video();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
				//echo $editor->register_script( $widget_object );
			}

			$widget_object                              = new piotnetgrid_Icon();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			echo $editor->register_script( $widget_object );

			if (in_array($post_type, ['piotnetgrid-card'])) {
	            $widget_object                              = new piotnetgrid_Product_Badge();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );
	            //echo $editor->register_script( $widget_object );
            }

            if (in_array($post_type, ['piotnetgrid-card'])) {
	            $widget_object                              = new piotnetgrid_Add_To_Wishlist();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );

	            $widget_object                              = new piotnetgrid_Button_Quick_View();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );
            }

			if (in_array($post_type, ['piotnetgrid-card'])) {
				$widget_object                              = new piotnetgrid_Product_Rating();
				$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
				$editor->register_widget( $widget_object );
				echo $editor->register_script( $widget_object );
			}

			if (in_array($post_type, ['piotnetgrid-card'])) {
				$widget_object                              = new Piotnetgrid_Variation_Swatches();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );

	            $widget_object                              = new Piotnetgrid_Add_To_Cart_Button();
	            $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
	            $editor->register_widget( $widget_object );
	            // echo $editor->register_script( $widget_object );
            }

			// $widget_object                              = new piotnetgrid_Divider();
			// $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			// $editor->register_widget( $widget_object );
			// echo $editor->register_script( $widget_object );

			$widget_object                              = new piotnetgrid_Shortcode();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );

			$widget_object                              = new piotnetgrid_Global_General();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			echo $editor->register_script( $widget_object );
			$global_settings_structure[$widget_object->get_type()] = array(
				'type' => $widget_object->get_type(),
				'fields' => [],
			);

			$widget_object                              = new piotnetgrid_Single_Settings();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			echo $editor->register_script( $widget_object );
			$single_settings_structure[$widget_object->get_type()] = array(
				'type' => $widget_object->get_type(),
				'fields' => [],
			);

			// $widget_object                              = new piotnetgrid_Social_Icon();
			// $widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			// $editor->register_widget( $widget_object );
			// echo $editor->register_script( $widget_object );

			$widget_object                              = new piotnetgrid_Icon_List();
			$widget_infos[ $widget_object->get_type() ] = $widget_object->get_info();
			$editor->register_widget( $widget_object );
			if (empty($preview_card_post_id)) {
				echo $editor->register_script( $widget_object );
			}

			echo '<div class="piotnetgrid-editor__collapse-button-open" title="Open Editor" data-piotnetgrid-editor-collapse-button-open><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-collapse-open.svg"></div>';

			echo '<div class="piotnetgrid-editor">';

			echo '<div class="piotnetgrid-settings">';
				$editor->editor_panel();
			echo '</div>';

			// echo '<div class="piotnetgrid-widget-preview piotnetgrid" id="piotnetgrid" data-piotnetgrid-widget-preview data-piotnetgrid-sortable>';
			// 	$editor->editor_preview( $widgets_settings );
			// echo '</div>';

			?>
				<div class="piotnetgrid-editor__settings-menu" data-piotnetgrid-settings-menu<?php if (get_post_type($post_id) == 'piotnetgrid-archive') : ?> data-piotnetgrid-settings-menu-archive-template<?php endif; ?>>
					<div class="piotnetgrid-editor__settings-menu-item" data-piotnetgrid-settings-menu-item="global-general">
						General Global Settings
					</div>
					<?php if (get_post_type($post_id) == 'piotnetgrid-archive') : ?>
						<div class="piotnetgrid-editor__settings-menu-item" data-piotnetgrid-settings-menu-item="single-settings">
							Display Conditions
						</div>
					<?php endif; ?>
					<?php if (get_post_type($post_id) == 'piotnetgrid-card') : ?>
						<div class="piotnetgrid-editor__settings-menu-item" data-piotnetgrid-settings-menu-item="single-settings">
							Preview Card Settings
						</div>
					<?php endif; ?>
				</div>
			<?php

			echo '<div class="piotnetgrid-editor__bottom">';
				echo '<div class="piotnetgrid-editor__tools">';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__device-desktop" data-piotnetgrid-control-responsive="desktop"><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-desktop.svg"></div>';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__device-tablet" data-piotnetgrid-control-responsive="tablet"><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-tablet.svg"></div>';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__device-mobile" data-piotnetgrid-control-responsive="mobile"><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-mobile.svg"></div>';
					
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__view"><a href="' . get_permalink($post_id) . '" target="_blank"><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-view.svg"></a></div>';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__tools-item--settings" data-piotnetgrid-settings-menu-toggle><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-global-settings.svg" title="Settings"></div>';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__wp-dashboard"><a href="' . admin_url( 'edit.php?post_type=' . get_post_type($post_id) ) . '"><i class="fab fa-wordpress-simple"></i></a></div>';
					echo '<div class="piotnetgrid-editor__tools-item piotnetgrid-editor__navigator" data-piotnetgrid-navigator-toggle><img src="' . plugin_dir_url( __FILE__ ) . '../../assets/images/i-layer.svg" title="Navigator"></div>';
				echo '</div>';

				echo '<div class="piotnetgrid-editor__save" data-piotnetgrid-editor-save><i class="far fa-save"></i><i class="icon-spinner-of-dots"></i> Save</div>';
			echo '</div>';

			echo '</div>';

			// echo '<br>';

			echo "<div class='piotnetgrid-navigator piotnetgrid-navigator-hidden'>
			    <div class='piotnetgrid-navigator-header'>
					<i class='piotnetgrid-navigator-toggle-all icon-angle-down'></i>
					<div class='piotnetgrid-navigator-header-title' style='font-weight: 600;'>Navigator</div>
					<i class='piotnetgrid-navigator-close fas fa-times'></i>
				</div>
				<div class='piotnetgrid-navigator-widgets'></div>
			</div>";

            echo "<div><input type='hidden' name='piotnetgrid-widget-post-id' value='{$post_id}' data-piotnetgrid-widget-post-id></div>";
			echo "<div><input type='hidden' name='piotnetgrid-widget-breakpoint-tablet' value='1025px' data-piotnetgrid-widget-breakpoint-tablet></div>";
			echo "<div><input type='hidden' name='piotnetgrid-widget-breakpoint-mobile' value='767px' data-piotnetgrid-widget-breakpoint-mobile></div>";

			$htmlspecialchars_data = htmlspecialchars($piotnetgrid_data, ENT_QUOTES, 'UTF-8');
			echo "<div><textarea style='display:none' name='piotnetgrid-data' data-piotnetgrid-data>{$htmlspecialchars_data}</textarea></div>";

			$piotnetgrid_global_settings = !empty(get_option( 'piotnetgrid_global_settings' )) ? stripslashes( get_option( 'piotnetgrid_global_settings' ) ) : json_encode($global_settings_structure);
			$htmlspecialchars_global_settings = htmlspecialchars($piotnetgrid_global_settings, ENT_QUOTES, 'UTF-8');

			if (!empty($htmlspecialchars_global_settings)) {
				$htmlspecialchars_global_settings_array = json_decode($piotnetgrid_global_settings, true);
				foreach ($htmlspecialchars_global_settings_array as $key => $value) {
					if (!isset($global_settings_structure[$key])) {
						$htmlspecialchars_global_settings_array[$key] = $global_settings_structure[$key];
					}
				}
			}

			$htmlspecialchars_global_settings = json_encode($htmlspecialchars_global_settings_array);

			echo "<div><textarea style='display:none' name='piotnetgrid-global-style' data-piotnetgrid-global-style>{$htmlspecialchars_global_settings}</textarea></div>";

			$piotnetgrid_single_settings = !empty(get_post_meta( $post_id, '_piotnetgrid_single_settings', true )) ? stripslashes(get_post_meta( $post_id, '_piotnetgrid_single_settings', true )) : json_encode($single_settings_structure);
			$htmlspecialchars_single_settings = htmlspecialchars($piotnetgrid_single_settings, ENT_QUOTES, 'UTF-8');

			if (!empty($htmlspecialchars_single_settings)) {
				$htmlspecialchars_single_settings_array = json_decode($piotnetgrid_single_settings, true);
				foreach ($htmlspecialchars_single_settings_array as $key => $value) {
					if (!isset($single_settings_structure[$key])) {
						$htmlspecialchars_single_settings_array[$key] = $single_settings_structure[$key];
					}
				}
			}

			$htmlspecialchars_single_settings = json_encode($htmlspecialchars_single_settings_array);

			echo "<div><textarea style='display:none' name='piotnetgrid-single-settings' data-piotnetgrid-single-settings>{$htmlspecialchars_single_settings}</textarea></div>";

			// Collape Menu
			// echo "<script>jQuery(document).ready(function( $ ) { $('body').addClass('folded'); })</script>";
			$form_title = ! empty( get_the_title($post_id) ) ? get_the_title($post_id) : ( 'Piotnet Grid #' . $post_id );
			echo '<div data-piotnetgrid-form-title="' . $form_title . '"></div>';
			echo '<div data-piotnetgrid-ajax-url="' . admin_url( 'admin-ajax.php' ) . '"></div>';
			echo '<div data-piotnetgrid-tinymce-upload="' . plugins_url() . '/piotnetgrid-pro/inc/tinymce/tinymce-upload.php"></div>';
			echo '<div data-piotnetgrid-stripe-key="' . esc_attr( get_option( 'piotnetgrid-stripe-publishable-key' ) ) . '"></div>';

			$dynamic_tags = array(
				'post' => array(
					'text' => 'Post',
					'submenu' => array(
						'post_title' => array(
							'text' => 'Post Title',
							'tag' => '{{post_title | length:0}}',
						),
						'post_url' => array(
							'text' => 'Post URL',
							'tag' => '{{post_url}}',
						),
						'post_content' => array(
							'text' => 'Post Content',
							'tag' => '{{post_content | length:0}}',
						),
						'post_excerpt' => array(
							'text' => 'Post Excerpt',
							'tag' => '{{post_excerpt | length:50}}',
						),
						'post_time' => array(
							'text' => 'Post Time',
							'tag' => '{{post_time | format:F j, Y}}',
						),
                        'post_modified_time' => array(
                            'text' => 'Post Modified Time',
                            'tag' => '{{post_modified_time | format:F j, Y}}',
                        ),
						'post_comments_number' => array(
							'text' => 'Post Comments Number',
							'tag' => '{{post_comments_number}}',
						),
						'post_terms' => array(
							'text' => 'Post Terms',
							'tag' => '{{post_terms | taxonomy:tags | separator:, | link:true}}',
						),
						'post_id' => array(
							'text' => 'Post ID',
							'tag' => '{{post_id}}',
						),
						'post_featured_image' => array(
							'text' => 'Post Featured Image',
							'tag' => '{{post_featured_image | size:full}}',
						),
					),
				),
				'custom_field' => array(
					'text' => 'Custom Field',
					'submenu' => array(
						'post_custom_field' => array(
							'text' => 'Post Custom Field',
							'tag' => '{{post_custom_field | name:your_field_name}}',
						),
						'acf_field' => array(
							'text' => 'ACF Field',
							'tag' => '{{acf_field | name:your_field_name}}',
						),
						'metabox_field' => array(
							'text' => 'Metabox Field',
							'tag' => '{{metabox_field | name:your_field_name}}',
						),
						'pods_field' => array(
							'text' => 'Pods Field',
							'tag' => '{{pods_field | name:your_field_name}}',
						),
						'toolset_field' => array(
							'text' => 'Toolset Field',
							'tag' => '{{toolset_field | name:your_field_name}}',
						),
						'jetengine_field' => array(
							'text' => 'JetEngine Field',
							'tag' => '{{jetengine_field | name:your_field_name}}',
						),
					),
				),
				'author_info' => array(
					'text' => 'Author Info',
					'submenu' => array(
						'author_info_display_name' => array(
							'text' => 'Author Display Name',
							'tag' => '{{author_info | meta:display_name}}',
						),
						'author_info_nicename' => array(
							'text' => 'Author Nice Name',
							'tag' => '{{author_info | meta:user_nicename}}',
						),
						'author_info_email' => array(
							'text' => 'Author Email',
							'tag' => '{{author_info | meta:user_email}}',
						),
						'author_info_description' => array(
							'text' => 'Author Bio',
							'tag' => '{{author_info | meta:description}}',
						),
						'author_info_meta' => array(
							'text' => 'Author Meta',
							'tag' => '{{author_info | meta:user_meta}}',
						),
					),
				),
				'wc' => array(
					'text' => 'Woocommerce',
					'submenu' => array(
						'wc_product_title' => array(
							'text' => 'Product Title',
							'tag' => '{{wc_product_title}}',
						),
						'wc_product_price' => array(
							'text' => 'Product Price',
							'submenu' => array(
								'wc_product_price_full' => array(
									'text' => 'Full Price',
									'tag' => '{{wc_product_price | format:full}}',
								),
								'wc_product_price_original' => array(
									'text' => 'Original Price',
									'tag' => '{{wc_product_price | format:original}}',
								),
								'wc_product_price_sale' => array(
									'text' => 'Sale Price',
									'tag' => '{{wc_product_price | format:sale}}',
								),
							),
						),
						'wc_product_discount_percentage' => array(
							'text' => 'Product Discount Percentage',
							'tag' => '{{wc_product_discount_percentage}}',
						),
						'wc_product_rating' => array(
							'text' => 'Product Rating',
							'tag' => '{{wc_product_rating}}',
						),
						'wc_product_short_description' => array(
							'text' => 'Product Short Description',
							'tag' => '{{wc_product_short_description | length:0}}',
						),
						'wc_product_terms' => array(
							'text' => 'Product Terms',
							'submenu' => array(
								'wc_product_terms_categories' => array(
									'text' => 'Product Categories',
									'tag' => '{{post_terms | taxonomy:product_cat | separator:, | link:true}}',
								),
								'wc_product_terms_tags' => array(
									'text' => 'Product Tags',
									'tag' => '{{post_terms | taxonomy:product_tag | separator:, | link:true}}',
								),
							),
						),
						'wc_category_thumbnail' => array(
							'text' => 'Category Thumbnail',
							'tag' => '{{wc_category_thumbnail}}',
						),
					),
				),
				'request' => array(
					'text' => 'URL Parameter',
					'tag' => '{{request | parameter:utm_source}}',
				),
				'current_date_time' => array(
					'text' => 'Current Date Time',
					'tag' => '{{current_date_time | date_format:Y-m-d H:i:s}}',
				),
				'shortcode' => array(
					'text' => 'Shortcode',
					'tag' => '{{shortcode | shortcode:[your_shortcode]}}',
				),
                'archive' => array(
                    'text' => 'Archive',
                    'submenu' => array(
                        'archive_title' => array(
                            'text' => 'Archive Title',
                            'tag' => '{{archive_title}}',
                        ),
                        'archive_description' => array(
                            'text' => 'Archive Description',
                            'tag' => '{{archive_description | length:0}}',
                        ),
                        'archive_meta' => array(
                            'text' => 'Archive Meta',
                            'tag' => '{{archive_meta | term_id:term_id | meta_key:meta_key}}',
                        ),
                    ),
                ),
                'term' => array(
                    'text' => 'Term',
                    'submenu' => array(
                        'term_name' => array(
                            'text' => 'Term Name',
                            'tag' => '{{term_name}}',
                        ),
                        'term_description' => array(
                            'text' => 'Term Description',
                            'tag' => '{{term_description}}',
                        ),
                        'term_url' => array(
                            'text' => 'Term URL',
                            'tag' => '{{term_url}}',
                        ),
                        'term_count' => array(
                            'text' => 'Term Count',
                            'tag' => '{{term_count}}',
                        ),
                        'term_color' => array(
                            'text' => 'Term Color',
                            'tag' => '{{term_color}}',
                        ),
                        'term_image' => array(
                            'text' => 'Term Image',
                            'tag' => '{{term_image}}',
                        ),
                        'term_meta' => array(
                            'text' => 'Term Meta',
                            'tag' => '{{term_meta | meta_key:meta_key}}',
                        ),
                    ),
                ),
			);
			?>
			<ul class="piotnetgrid-control-dynamic-tags-menu" data-piotnetgrid-control-dynamic-tags-menu>
				<?php foreach ($dynamic_tags as $key => $tag) : ?>
					<li class="piotnetgrid-control-dynamic-tags-menu__item"<?php if(!empty($tag['tag'])) { echo ' data-piotnetgrid-control-dynamic-tag="' . $tag['tag'] . '"'; } ?>>
						<span class="piotnetgrid-control-dynamic-tags-menu__item-text">
							<?php echo $tag['text']; ?>
						</span>
						<?php if (!empty($tag['submenu'])) : ?>
							<ul class="piotnetgrid-control-dynamic-tags-submenu">
								<?php foreach ($tag['submenu'] as $tag_submenu_name => $tag_submenu_item) : ?>
									<li class="piotnetgrid-control-dynamic-tags-menu__item"<?php if(!empty($tag_submenu_item['tag'])) { echo ' data-piotnetgrid-control-dynamic-tag="' . $tag_submenu_item['tag'] . '"'; } ?>>
										<span class="piotnetgrid-control-dynamic-tags-menu__item-text">
											<?php echo $tag_submenu_item['text']; ?>
										</span>
									</li>
									<?php if (!empty($tag_submenu_item['submenu'])) : ?>
										<ul class="piotnetgrid-control-dynamic-tags-submenu">
											<?php foreach ($tag_submenu_item['submenu'] as $tag_submenu_name_2 => $tag_submenu_item_2) : ?>
												<li class="piotnetgrid-control-dynamic-tags-menu__item"<?php if(!empty($tag_submenu_item_2['tag'])) { echo ' data-piotnetgrid-control-dynamic-tag="' . $tag_submenu_item_2['tag'] . '"'; } ?>>
													<span class="piotnetgrid-control-dynamic-tags-menu__item-text">
														<?php echo $tag_submenu_item_2['text']; ?>
													</span>
												</li>
											<?php endforeach; ?>
										</ul>
									<?php endif; ?>
								<?php endforeach; ?>
							</ul>
						<?php endif; ?>
					</li>
				<?php endforeach; ?>
			</ul>

			<style>
				html.wp-toolbar {
				    padding-top: 0;
				    box-sizing: border-box;
				}

				html, body {
					height: 100%;
					overflow: hidden;
				}

				#wpadminbar {
					display: none;
				}

				#post-body {
					display: flex;
					flex-wrap: wrap;
					margin-right: 0 !important;
				}

				#postbox-container-1 {
					float:right !important;
					margin-right: 0 !important;
					order: 3;
					width: 100% !important;
				}

				#side-sortables {
					width: 100% !important;
				}
			</style>
			<?php

			$controls_manager = new Controls_Manager_piotnetgrid();
			$controls_manager->render();

			echo '<script type="text/json" id="widget_infos">' . json_encode( $widget_infos ) . '</script>';
			echo $this->tab_widget_template();
			echo $this->output_template();
			echo $this->division_output_template();

			$post_url = get_permalink( $post_id );

			if (is_ssl()) {
				$post_url = str_replace('http://', 'https://', $post_url);
			}

			$request_parameter = (strpos($post_url, '?') !== false) ? '&' : '?';

				echo '<div class="piotnetgrid-preview">';
					echo '<div class="piotnetgrid-preview__inner" data-piotnetgrid-preview-inner>';
						echo '<iframe class="piotnetgrid-preview__iframe" data-piotnetgrid-preview-iframe="' . $post_url . $request_parameter. 'action=piotnetgrid"></iframe>';
					echo '</div>';
				echo '</div>';
				echo '<div class="piotnetgrid-editor__loading active" data-piotnetgrid-editor-loading><div class="lds-ellipsis"><div></div><div></div><div></div><div></div></div></div>';
			echo '</div>';
		}
	} else {
?>
	<div class="wrap">
		<div class="piotnetgrid-header">
			<div class="piotnetgrid-header__left">
				<div class="piotnetgrid-header__logo">
					<img src="<?php echo plugin_dir_url( __FILE__ ) . '../../assets/images/piotnet.svg'; ?>" alt="">
				</div>
				<h2 class="piotnetgrid-header__headline"><?php esc_html_e( 'Piotnet Grid Settings', 'piotnetgrid' ); ?></h2>
			</div>
			<div class="piotnetgrid-header__right">
					<a class="piotnetgrid-header__button piotnetgrid-header__button--gradient" href="https://piotnetgrid.com/?wpam_id=1" target="_blank">
					<?php
					if ( !$has_valid_license ) {
						esc_html_e( 'Buy It Now', 'piotnetgrid' );
					} else {
						esc_html_e( 'Go to Piotnet Grid', 'piotnetgrid' ); }
					?>
					</a>
			</div>
		</div>
		<div class="piotnetgrid-wrap">
            <?php require_once "settings-license.php"; ?>
		</div>
	</div>
<?php } ?>
