<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

// require all widgets
foreach ( glob( __DIR__ . '/../widgets/*.php' ) as $file ) {
	require_once $file;
}

require_once(__DIR__.'/../dynamic-tags.php');

function piotnetgrid_shortcode( $args, $content ) {
	ob_start();
	if ( ! empty( $args['id'] ) ) {
		$post_id         = $args['id'];
		$raw_data = get_post_meta( $post_id, '_piotnetgrid_data', true );
		$form_id = !empty($args['form_id']) ? $args['form_id'] : '';
		$editor = !empty($args['editor']) ? $args['editor'] : false;
		$args_additional = [];

		foreach ($args as $key => $value) {
			$args_additional[$key] = $value;
		}

		if ( ! empty( $raw_data ) ) {
			wp_enqueue_style( 'piotnetgrid-style' );
			wp_enqueue_style( 'piotnetgrid-global-style' );
			wp_enqueue_script( 'piotnetgrid-script' );

			$class_id = !empty($GLOBALS['term']) && is_object($GLOBALS['term']) ? $GLOBALS['term']->term_id : get_the_ID();
			echo '<div id="piotnetgrid" class="piotnetgrid piotnetgrid-fadein piotnetgrid-' . $class_id . '" data-piotnetgrid-shortcode-id="' . $post_id . '"';
			if ( is_user_logged_in() && current_user_can( 'edit_others_posts' ) ) {
				echo ' data-piotnetgrid-shortcode-title="' . get_the_title($post_id) . '"';
			}
			echo '>';
			$data = json_decode( $raw_data, true );
			$widget_content = $data['content'];
			@piotnetgrid_render_loop( $widget_content, $post_id, $form_id, $editor, $args_additional );

			$upload = wp_upload_dir();
			$upload_dir = $upload['baseurl'];
			$upload_dir = $upload_dir . '/piotnetgrid/css/';

			$css_file = $upload_dir . $post_id . ".css";
			echo '</div>';

            // piotnetgrid_enqueue_footer();
            if (!empty($args['editor'])) {
            	echo "<link rel='stylesheet' href='" . $css_file . '?ver=' . get_post_meta( $post_id, '_piotnetgrid-revision-version', true ) . "' media='all'>";
            }
			wp_enqueue_style( 'piotnetgrid-style-' . $post_id, $css_file, [], get_post_meta( $post_id, '_piotnetgrid-revision-version', true ) );			
		}
	}
	return ob_get_clean();
}
add_shortcode( 'piotnetgrid', 'piotnetgrid_shortcode' );

function piotnetgrid_render_loop( $loop, $post_id, $form_id='', $editor=false, $args_additional=[] ) {
	foreach ( $loop as $widget_item ) {
		$widget = new $widget_item['class_name'];

		if (!empty($form_id)) {
			if (isset($widget_item['settings']['form_id'])) {
				$widget_item['settings']['form_id'] = $form_id;
			}
			if (isset($widget_item['settings']['piotnetgrid_conditional_logic_form_form_id'])) {
				$widget_item['settings']['piotnetgrid_conditional_logic_form_form_id'] = $form_id;
			}
			if (isset($widget_item['settings']['piotnetgrid_booking_form_id'])) {
				$widget_item['settings']['piotnetgrid_booking_form_id'] = $form_id;
			}
			if (isset($widget_item['settings']['piotnetgrid_woocommerce_checkout_form_id'])) {
				$widget_item['settings']['piotnetgrid_woocommerce_checkout_form_id'] = $form_id;
			}
		}

		$widget->settings  = $widget_item['settings'];
		$widget_id         = $widget_item['id'];
		$widget->widget_id = $widget_id;
		$widget->post_id   = $post_id;

		if ( ! empty( $widget_item['fonts'] ) ) {
			$fonts = $widget_item['fonts'];
			if ( ! empty( $fonts ) ) {
				echo '<script>jQuery(document).ready(function( $ ) {';
				foreach ( $fonts as $font ) :
					?>
					$('head').append('<link href="<?php echo $font; ?>" rel="stylesheet">');
					<?php
				endforeach;
				echo '})</script>';
			}
		}

		$widget_type = $widget->get_type();
		if ( $widget_type === 'section' || $widget_type === 'column' ) {
			$visibility = @$widget->widget_visibility();
			if ($visibility) {
				echo piotnetgrid_dynamic_tags(@$widget->output_wrapper_start( $widget_id ));
				if ( isset( $widget_item['elements'] ) ) {
					echo @piotnetgrid_render_loop( $widget_item['elements'], $post_id, $form_id, $editor, $args_additional );
				}
			}
		} else {
			if ($editor) {
				$args_additional['editor'] = true;
			}
			$output = $widget->output( $widget_id, false, $args_additional );
			$output = piotnetgrid_dynamic_tags( $output );
			echo @$output;
		}

		if ( $widget_type === 'section' || $widget_type === 'column' ) {
			echo @$widget->output_wrapper_end( $widget_id );
		}
	}
}

function piotnetgrid_enqueue_footer() {
	echo '<div data-piotnetgrid-ajax-url="' . admin_url( 'admin-ajax.php' ) . '"></div>';
	echo '<div data-piotnetgrid-plugin-url="' . plugins_url() . '"></div>';
	echo '<div class="piotnetgrid-break-point" data-piotnetgrid-break-point-md="1025" data-piotnetgrid-break-point-lg="767"></div>';
}