<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit; }

function piotnetgrid_get_css( $post_id ) {
	$upload_dir = wp_upload_dir()['baseurl'] . '/piotnetgrid/css/';
	$css_path   = $upload_dir . $post_id . '.css';
	return file_get_contents( $css_path );
}

function piotnetgrid_remove_settings_in_content( $content ) {
	$length = count( $content );
	for ( $i = 0; $i <= $length - 1; $i++ ) {
		unset( $content[ $i ]['settings'] );
		unset( $content[ $i ]['fonts'] );

		if ( isset( $content[ $i ]['elements'] ) ) {
			$content[ $i ]['elements'] = piotnetgrid_remove_settings_in_content( $content[ $i ]['elements'] );
		}
	}
	return $content;
}

function piotnetgrid_export_post( $post_id ) {
	$post = get_post( $post_id );
	if ( is_null( $post ) ) {
		return [ 'error' => "the post doesn't exists" ];
	}

	$post_meta = get_post_meta( $post_id, '_piotnetgrid_data', true );
	if ( empty( $post_meta ) ) {
		return [ 'error' => "the post haven't piotnetgrid data" ];
	}

	$post_meta_settings = json_decode( $post_meta, true );

	foreach ($post_meta_settings['widgets'] as $key => $widget) {
		if ($widget['type'] == 'grid') {
			if (!empty($post_meta_settings['widgets'][$key]['settings']['card_template'])) {
				$post_meta_settings['widgets'][$key]['settings']['card_template'] = 'export' . $post_meta_settings['widgets'][$key]['settings']['card_template']; 
			}
			
			if (!empty($post_meta_settings['widgets'][$key]['settings']['cache_enable'])) {
				$post_meta_settings['widgets'][$key]['settings']['cache_enable'] = '';
				$post_meta_settings['widgets'][$key]['settings']['cache_boost_loading'] = '';
			}
		}

		if ($widget['type'] == 'grid_embed') {
			if (!empty($post_meta_settings['widgets'][$key]['settings']['grid'])) {
				$post_meta_settings['widgets'][$key]['settings']['grid'] = 'export' . $post_meta_settings['widgets'][$key]['settings']['grid']; 
			}
		}

		if ($widget['type'] == 'facet_embed') {
			if (!empty($post_meta_settings['widgets'][$key]['settings']['facet'])) {
				$post_meta_settings['widgets'][$key]['settings']['facet'] = 'export' . $post_meta_settings['widgets'][$key]['settings']['facet'];
			}
			
			if (!empty($post_meta_settings['widgets'][$key]['settings']['facet_grid'])) {
				$post_meta_settings['widgets'][$key]['settings']['facet_grid'] = 'export' . $post_meta_settings['widgets'][$key]['settings']['facet_grid'];
			}
		}
	}

	return [
		'post_type' => $post->post_type,
		'post_id' => $post_id,
		'title'   => $post->post_title,
		'version' => $post_meta_settings['version'],
		'widgets' => $post_meta_settings['widgets'],
		'content' => piotnetgrid_remove_settings_in_content( $post_meta_settings['content'] ),
		'css'     => piotnetgrid_get_css( $post_id ),
	];
}
