<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Grid_Embed_Elementor extends \Elementor\Widget_Base {
	public function get_name() {
		return 'grid_embed';
	}

	public function get_title() {
		return 'Grid';
	}

	public function get_icon() {
		return 'piotnetgrid-icon piotnetgrid-icon--grid';
	}

	public function get_categories() {
		return [ 'piotnetgrid' ];
	}

	public function get_keywords() {
		return [ 'grid', 'piotnetgrid', 'piotnet' ];
	}

	public function get_script_depends() {
		return [ 
			'piotnetgrid-script',
		];
	}

	public function get_style_depends() {
		return [ 
			'piotnetgrid-style',
			'piotnetgrid-fontawesome-style',
		];
	}

	protected function _register_controls() {
		$this->start_controls_section(
			'grid_section',
			[
				'label' => __( 'Grid', 'piotnetgrid' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$grid_query = new WP_Query(
			array(
				'post_type' => 'piotnetgrid',
				'posts_per_page' => -1,
			)
		);

		$grids = [];

		if($grid_query->have_posts()) : while($grid_query->have_posts()) : $grid_query->the_post();
			$grids[ get_the_ID() ] = html_entity_decode( get_the_title() );
		endwhile; endif; wp_reset_postdata();

		$this->add_control(
			'grid',
			[
				'type' => \Elementor\Controls_Manager::SELECT,
				'label' => __( 'Select a grid', 'piotnetgrid' ),
				'options' => $grids,
				'default' => '',
			]
		);

		$this->end_controls_section();
	}

	public function render() {
		$settings = $this->get_settings_for_display();
		$grid = !empty($settings['grid']) ? $settings['grid'] : '';
		$editor_attr = \Elementor\Plugin::$instance->editor->is_edit_mode() ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $grid . ' type=grid' . $editor_attr . ']';

		if ( ! empty( $grid ) ) {
			echo '<div ' . $this->get_render_attribute_string( 'wrapper' ) . '>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
}
