<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Template_Elementor extends \Elementor\Widget_Base {
	public function get_name() {
		return 'template';
	}

	public function get_title() {
		return 'Template';
	}

	public function get_icon() {
		return 'piotnetgrid-icon piotnetgrid-icon--template';
	}

	public function get_categories() {
		return [ 'piotnetgrid' ];
	}

	public function get_keywords() {
		return [ 'template', 'grid', 'piotnetgrid', 'piotnet' ];
	}

	public function get_script_depends() {
		return [ 
			'piotnetgrid-script',
		];
	}

	public function get_style_depends() {
		return [ 
			'piotnetgrid-style',
			'piotnetgrid-fontawesome-style',
		];
	}

	protected function _register_controls() {
		$this->start_controls_section(
			'template_section',
			[
				'label' => __( 'Template', 'piotnetgrid' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		$template_query = new WP_Query(
			array(
				'post_type' => 'piotnetgrid-template',
				'posts_per_page' => -1,
				'post__not_in' => [$_GET['post']],
			)
		);

		$templates = [];

		if($template_query->have_posts()) : while($template_query->have_posts()) : $template_query->the_post();
			$templates[ get_the_ID() ] = get_the_title();
		endwhile; endif; wp_reset_postdata();

		$this->add_control(
			'template',
			[
				'type' => \Elementor\Controls_Manager::SELECT,
				'label'       => __( 'Select a Template', 'piotnetgrid' ),
				'options'     => $templates,
				'default' => '',
			]
		);

		$this->end_controls_section();
	}

	public function render() {
		$settings = $this->get_settings_for_display();
		$template = !empty($settings['template']) ? $settings['template'] : '';
		$editor_attr = \Elementor\Plugin::$instance->editor->is_edit_mode() ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $template . ' type=template' . $editor_attr . ']';

		if ( ! empty( $template ) ) {
			echo '<div ' . $this->get_render_attribute_string( 'wrapper' ) . '>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
}