<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Global_General extends Base_Widget_piotnetgrid {

	protected $is_add_conditional_logic = false;

	public $is_global = true;

	public function get_type() {
		return 'global-general';
	}

	public function get_class_name() {
		return 'piotnetgrid_Global_General';
	}

	public function get_title() {
		return 'General Global Settings';
	}

	public function get_icon() {
		return [
			'type' => 'image',
			'value' => plugin_dir_url( __FILE__ ) . '../../assets/icons/i-field.svg',
		];
	}

	public function get_categories() {
		return [ 'piotnetgrid' ];
	}

	public function get_keywords() {
		return [ 'form' ];
	}

	public function register_controls() {
		$this->start_tab( 'settings', 'General Global Settings' );

		$this->start_section( 'section_general_global_settings', 'Settings' );

		$this->add_responsive_control(
			'column_gutter',
			[
				'type'        => 'text',
				'label'       => __( 'Column Gutter', 'piotnetgrid' ),
				'label_block' => true,
				'description' => 'Default: 10px',
				'selectors'   => [
					'{{GLOBAL}} .piotnetgrid-column' => 'padding: {{VALUE}};',
				],
			]
		);

		$this->add_control(
			'custom_css',
			[
				'type'        => 'textarea',
				'label'       => __( 'Custom CSS', 'piotnetgrid' ),
				'label_block' => true,
				'description' => 'This custom CSS will be placed inside the style tag. Click Save and Reload the page to see the result.',
			]
		);

		$this->add_control(
			'custom_js',
			[
				'type'        => 'textarea',
				'label'       => __( 'Custom Javascript', 'piotnetgrid' ),
				'label_block' => true,
				'description' => 'This custom javascript will be placed inside the script tag. Click Save and Reload the page to see the result.',
			]
		);

		return $this->structure;
	}

	public function render($editor = false, $args_additional = []) {
	}

	public function live_preview() {
	}
}
