<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Grid_Embed extends Base_Widget_piotnetgrid {
	public function get_type() {
		return 'grid_embed';
	}

	public function get_class_name() {
		return 'piotnetgrid_Grid_Embed';
	}

	public function get_title() {
		return 'Grid';
	}

	public function get_icon() {
		return [
			'type' => 'image',
			'value' => plugin_dir_url( __FILE__ ) . '../../assets/icons/i-grid.svg',
		];
	}

	public function get_categories() {
		return [ 'piotnetgrid' ];
	}

	public function get_keywords() {
		return [ 'grid' ];
	}

	public function register_controls() {
		$this->start_tab( 'settings', 'Settings' );

		$this->start_section( 'settings_section', 'Grid Settings' );
		$this->add_setting_controls();

		$this->add_advanced_tab();

		return $this->structure;
	}

	private function add_setting_controls() {

		$grid_query = new WP_Query(
			array(
				'post_type' => 'piotnetgrid',
				'posts_per_page' => -1,
			)
		);

		$grids = [];

		if($grid_query->have_posts()) : while($grid_query->have_posts()) : $grid_query->the_post();
			$grids[ get_the_ID() ] = html_entity_decode( get_the_title() );
		endwhile; endif; wp_reset_postdata();

		$this->add_control(
			'grid',
			[
				'type'        => 'select',
				'label'       => __( 'Select Grid', 'piotnetgrid' ),
				'options'     => $grids,
				'description_has_value' => '<a href="' . admin_url() . 'admin.php?page=piotnetgrid&post=' . '{{VALUE}}" target="_blank">Edit this grid</a>',
			]
		);
	}

	public function render($editor = false, $args_additional = []) {
		$settings = $this->settings;
		$grid = !empty($settings['grid']) ? $settings['grid'] : '';
		$editor_attr = $editor || !empty($args_additional['editor']) ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $grid . ' type=grid' . $editor_attr . ']';

		if ( ! empty( $grid ) && strpos( $grid, 'export' ) == false ) {
			echo '<div ' . $this->get_render_attribute_string( 'wrapper' ) . '>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}

	public function live_preview() {
		?>
		<?php
	}
}
