<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class PiotnetgridFacetOxygen extends OxyEl {
	public $css_added = false;

	function init()
	{
		$this->El->useAJAXControls();
	}
	
	function name() {
		return __( 'Facet', 'piotnetgrid' );
	}

	function slug() {
		return "piotnetgrid_facet_oxygen";
	}

	function button_place() {
		return "piotnetgrid::basic";
	}

	function button_priority() {
        return '';
    }

    function isBuilderEditorActive() {
		if( isset($_GET['oxygen_iframe']) || defined('OXY_ELEMENTS_API_AJAX') ) {
			return true;
		}

		return false;
    }

	function icon() {
		return plugin_dir_url( __FILE__ ) . '../../../assets/icons/i-facet-oxygen.svg';
	}

	function controls() {

		$facets = [];

		global $wpdb;

		$facet_posts = $wpdb->get_results( "SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE post_type = 'piotnetgrid-facet'", ARRAY_A );

		foreach ($facet_posts as $facet_post) {
			$facets[$facet_post['ID']] = $facet_post['post_title'];
		}

		$facet = $this->addOptionControl(
			array(
				'name' 			=> __( 'Select a facet', 'piotnetgrid' ),
				'slug' 			=> 'facet',
				'type' 			=> 'dropdown',
				'value' 		=> $facets,
				'default' 		=> '',
				'css'			=> false
			)
		);

		$facet->rebuildElementOnChange();


		$grids = [
			'0' => __( 'None', 'piotnetgrid' ),
			'0_oxygen' => __( 'Oxygen', 'piotnetgrid' ),
		];

		global $wpdb;

		$grid_posts = $wpdb->get_results( "SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE post_type = 'piotnetgrid'", ARRAY_A );

		foreach ($grid_posts as $grid_post) {
			$grids[$grid_post['ID']] = $grid_post['post_title'];
		}

		$grid = $this->addOptionControl(
			array(
				'name' 			=> __( 'Apply for Grid', 'piotnetgrid' ),
				'slug' 			=> 'facet_grid',
				'type' 			=> 'dropdown',
				'value' 		=> $grids,
				'default' 		=> '',
				'css'			=> false
			)
		);

		$grid->rebuildElementOnChange();

		$grid_oxygen = $this->addOptionControl(
			array(
				'name' 			=> __( 'Grid Unique ID ( The ID has to start with "piotnetgrid-id-" like "piotnetgrid-id-1" )', 'piotnetgrid' ),
				'slug' 			=> 'facet_grid_oxygen',
				'type' 			=> 'textfield',
				'default' 		=> '',
				'css'			=> false,
				'condition'     => 'facet_grid=0_oxygen'
			)
		);

		$grid_oxygen->rebuildElementOnChange();

		$this->addOptionControl(
			array(
				'name' 			=> __( 'Cache', 'piotnetgrid' ),
				'slug' 			=> 'facet_grid_cache_enable',
				'type' 			=> 'dropdown',
				'value' 		=> [
					'' => __( 'No', 'piotnetgrid' ),
					'yes' => __( 'Yes', 'piotnetgrid' ),
				],
				'default' 		=> '',
				'css'			=> false,
				'condition'     => 'facet_grid=0_oxygen'
			)
		);

		// $this->addOptionControl(
		// 	array(
		// 		'name' 			=> __( 'Boost Cache Loading', 'piotnetgrid' ),
		// 		'slug' 			=> 'facet_grid_cache_boost',
		// 		'type' 			=> 'dropdown',
		// 		'value' 		=> [
		// 			'' => __( 'No', 'piotnetgrid' ),
		// 			'yes' => __( 'Yes', 'piotnetgrid' ),
		// 		],
		// 		'default' 		=> '',
		// 		'css'			=> false,
		// 		'condition'     => 'facet_grid_cache=yes'
		// 	)
		// );

		$this->addOptionControl(
			array(
				'name' 			=> __( 'Expiration (seconds)', 'piotnetgrid' ),
				'slug' 			=> 'facet_grid_cache_expiration',
				'type' 			=> 'textfield',
				'default' 		=> '259200',
				'css'			=> false,
				'condition'     => 'facet_grid_cache_enable=yes'
			)
		);
	}

	function render($options, $defaults, $content ) {
		$facet = !empty($options['facet']) ? $options['facet'] : '';
		$grid = !empty($options['facet_grid']) ? $options['facet_grid'] : '';
		$grid = $grid == '0_oxygen' && !empty($options['facet_grid_oxygen']) ? $options['facet_grid_oxygen'] : $grid;
		$editor_attr = !empty($_GET['post_id']) ? ' editor=true' : '';
		$cache_attr = !empty($options['facet_grid_cache_enable']) ? ' cache=true' : '';
		$cache_expiration_attr = !empty($options['facet_grid_cache_expiration']) ? ' cache_expiration=' . $options['facet_grid_cache_expiration'] : '';
		$shortcode = '[piotnetgrid id=' . $facet . ' type=facet grid=' . $grid . $editor_attr . $cache_attr . $cache_expiration_attr . ']';

		if ( ! empty( $facet ) ) {
			echo '<div>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
}

new PiotnetgridFacetOxygen();