<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class PiotnetgridGridOxygen extends OxyEl {
	public $css_added = false;

	function init()
	{
		$this->El->useAJAXControls();
	}
	
	function name() {
		return __( 'Grid', 'piotnetgrid' );
	}

	function slug() {
		return "piotnetgrid_grid_oxygen";
	}

	function button_place() {
		return "piotnetgrid::basic";
	}

	function button_priority() {
        return '';
    }

    function isBuilderEditorActive() {
		if( isset($_GET['oxygen_iframe']) || defined('OXY_ELEMENTS_API_AJAX') ) {
			return true;
		}

		return false;
    }

	function icon() {
		return plugin_dir_url( __FILE__ ) . '../../../assets/icons/i-grid-oxygen.svg';
	}

	function controls() {
		$grid_query = new WP_Query(
			array(
				'post_type' => 'piotnetgrid',
				'posts_per_page' => -1,
			)
		);

		$grids = [];

		global $wpdb;

		$grid_posts = $wpdb->get_results( "SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE post_type = 'piotnetgrid'", ARRAY_A );

		foreach ($grid_posts as $grid_post) {
			$grids[$grid_post['ID']] = $grid_post['post_title'];
		}

		$grid = $this->addOptionControl(
			array(
				'name' 			=> __( 'Select a grid', 'piotnetgrid' ),
				'slug' 			=> 'grid',
				'type' 			=> 'dropdown',
				'value' 		=> $grids,
				'default' 		=> '',
				'css'			=> false
			)
		);

		$grid->rebuildElementOnChange();
	}

	function render($options, $defaults, $content ) {
		$grid = !empty($options['grid']) ? $options['grid'] : '';
		$editor_attr = !empty($_GET['post_id']) ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $grid . ' type=grid' . $editor_attr . ']';
		if ( ! empty( $grid ) ) {
			echo '<div>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
}

new PiotnetgridGridOxygen();