<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class PiotnetgridTemplateOxygen extends OxyEl {
	public $css_added = false;

	function init()
	{
		$this->El->useAJAXControls();
	}
	
	function name() {
		return __( 'Template', 'piotnetgrid' );
	}

	function slug() {
		return "piotnetgrid_template_oxygen";
	}

	function button_place() {
		return "piotnetgrid::basic";
	}

	function button_priority() {
        return '';
    }

    function isBuilderEditorActive() {
		if( isset($_GET['oxygen_iframe']) || defined('OXY_ELEMENTS_API_AJAX') ) {
			return true;
		}

		return false;
    }

	function icon() {
		return plugin_dir_url( __FILE__ ) . '../../../assets/icons/i-template-oxygen.svg';
	}

	function controls() {

		$templates = [];

		global $wpdb;

		$template_posts = $wpdb->get_results( "SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE post_type = 'piotnetgrid-template'", ARRAY_A );

		foreach ($template_posts as $template_post) {
			$templates[$template_post['ID']] = $template_post['post_title'];
		}

		$template = $this->addOptionControl(
			array(
				'name' 			=> __( 'Select a Template', 'piotnetgrid' ),
				'slug' 			=> 'template',
				'type' 			=> 'dropdown',
				'value' 		=> $templates,
				'default' 		=> '',
				'css'			=> false
			)
		);

		$template->rebuildElementOnChange();
	}

	function render($options, $defaults, $content ) {
		$template = !empty($options['template']) ? $options['template'] : '';
		$editor_attr = !empty($_GET['post_id']) ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $template . ' type=template' . $editor_attr . ']';
		if ( ! empty( $template ) ) {
			echo '<div>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
}

new PiotnetgridTemplateOxygen();