<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Shortcode extends Base_Widget_piotnetgrid {
	public function get_type() {
		return 'shortcode';
	}

	public function get_class_name() {
		return 'piotnetgrid_Shortcode';
	}

	public function get_title() {
		return 'Shortcode';
	}

	public function get_icon() {
		return [
			'type' => 'image',
			'value' => plugin_dir_url( __FILE__ ) . '../../assets/icons/i-shortcode.svg',
		];
	}

	public function get_categories() {
		return [ 'pafe-form-builder' ];
	}

	public function get_keywords() {
		return [ 'shortcode' ];
	}

	public function register_controls() {
		$this->start_tab( 'settings', 'Settings' );

		$this->start_section( 'shortcode_settings_section', 'Shortcode Settings' );
		$this->add_setting_controls();

		$this->add_advanced_tab();

		return $this->structure;
	}

	private function add_setting_controls() {
		$this->add_control(
			'shortcode',
			[
				'type'        => 'textarea',
				'label'       => __( 'Shortcode', 'piotnetgrid' ),
				'value'       => '',
				'description' => __( 'Enter your short code', 'piotnetgrid' ),
				'dynamic'     => true,
			]
		);
	}

	public function render($editor = false, $args_additional = []) {
		$settings = $this->settings;
		$shortcode = $settings['shortcode'];
		if ( ! empty( $shortcode ) ) {
			if ($editor && stripos( $shortcode, 'piotnetgrid' ) !== false) {
				$shortcode_explode = explode(']', $shortcode);
				$shortcode = $shortcode_explode[0] . ' editor=true]';
			}
			echo '<div ' . $this->get_render_attribute_string( 'wrapper' ) . '>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}
	public function live_preview() {
		?>
		<%
		
		%>
		<?php
	}
}
