<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

class piotnetgrid_Template extends Base_Widget_piotnetgrid {
	public function get_type() {
		return 'template';
	}

	public function get_class_name() {
		return 'piotnetgrid_Template';
	}

	public function get_title() {
		return 'Template';
	}

	public function get_icon() {
		return [
			'type' => 'image',
			'value' => plugin_dir_url( __FILE__ ) . '../../assets/icons/i-template.svg',
		];
	}

	public function get_categories() {
		return [ 'piotnetgrid' ];
	}

	public function get_keywords() {
		return [ 'template' ];
	}

	public function register_controls() {
		$this->start_tab( 'settings', 'Settings' );

		$this->start_section( 'settings_section', 'Template Settings' );
		$this->add_setting_controls();

		$this->add_advanced_tab();

		return $this->structure;
	}

	private function add_setting_controls() {

		$template_query = new WP_Query(
			array(
				'post_type' => 'piotnetgrid-template',
				'posts_per_page' => -1,
				'post__not_in' => isset($_GET['post']) ? [$_GET['post']] : [],
			)
		);

		$templates = [];

		if($template_query->have_posts()) : while($template_query->have_posts()) : $template_query->the_post();
			$templates[ get_the_ID() ] = get_the_title();
		endwhile; endif; wp_reset_postdata();

		$this->add_control(
			'template',
			[
				'type'        => 'select',
				'label'       => __( 'Select a Template', 'piotnetgrid' ),
				'options'     => $templates,
				'description_has_value' => '<a href="' . admin_url() . 'admin.php?page=piotnetgrid&post=' . '{{VALUE}}" target="_blank">Edit this template</a>',
			]
		);
	}

	public function render($editor = false, $args_additional = []) {
		$settings = $this->settings;
		$template = !empty($settings['template']) ? $settings['template'] : '';
		$editor_attr = $editor ? ' editor=true' : '';
		$shortcode = '[piotnetgrid id=' . $template . ' type=template' . $editor_attr . ']';

		if ( ! empty( $template ) ) {
			echo '<div ' . $this->get_render_attribute_string( 'wrapper' ) . '>';
			echo do_shortcode( $shortcode );
			echo '</div>';
		}
	}

	public function live_preview() {
		?>
		<?php
	}
}